/*
Copyright (c) 2010 - 2023, Nordic Semiconductor ASA All rights reserved.\n
\n
SPDX-License-Identifier: BSD-3-Clause\n
\n
Redistribution and use in source and binary forms, with or without\n
modification, are permitted provided that the following conditions are met:\n
\n
1. Redistributions of source code must retain the above copyright notice, this\n
   list of conditions and the following disclaimer.\n
\n
2. Redistributions in binary form must reproduce the above copyright\n
   notice, this list of conditions and the following disclaimer in the\n
   documentation and/or other materials provided with the distribution.\n
\n
3. Neither the name of Nordic Semiconductor ASA nor the names of its\n
   contributors may be used to endorse or promote products derived from this\n
   software without specific prior written permission.\n
\n
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"\n
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\n
IMPLIED WARRANTIES OF MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE\n
ARE DISCLAIMED. IN NO EVENT SHALL NORDIC SEMICONDUCTOR ASA OR CONTRIBUTORS BE\n
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\n
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\n
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\n
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\n
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\n
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\n
POSSIBILITY OF SUCH DAMAGE.\n
 *
 * @file     /jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/_generated/Header/nrf52833.h
 * @brief    CMSIS HeaderFile
 * @version  1
 * @date     Thu Jul 13 08:31:43 2023
 * @note     Generated by SVDConv V3.3.44
 *           from File '/jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/source/files/svd/external/nrf52833.svd',
 *           last modified on Thu Jul 13 08:29:48 2023
 */


/** @addtogroup Nordic Semiconductor
  * @{
  */


/** @addtogroup nrf52833
  * @{
  */


#ifndef NRF52833_H
#define NRF52833_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M4 Specific Interrupt Numbers  ======================================== */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* ==========================================  nrf52833 Specific Interrupt Numbers  ========================================== */
  POWER_CLOCK_IRQn          =   0,              /*!< 0  POWER_CLOCK                                                            */
  RADIO_IRQn                =   1,              /*!< 1  RADIO                                                                  */
  UARTE0_UART0_IRQn         =   2,              /*!< 2  UARTE0_UART0                                                           */
  SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn=   3,  /*!< 3  SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0                                      */
  SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn=   4,  /*!< 4  SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1                                      */
  NFCT_IRQn                 =   5,              /*!< 5  NFCT                                                                   */
  GPIOTE_IRQn               =   6,              /*!< 6  GPIOTE                                                                 */
  SAADC_IRQn                =   7,              /*!< 7  SAADC                                                                  */
  TIMER0_IRQn               =   8,              /*!< 8  TIMER0                                                                 */
  TIMER1_IRQn               =   9,              /*!< 9  TIMER1                                                                 */
  TIMER2_IRQn               =  10,              /*!< 10 TIMER2                                                                 */
  RTC0_IRQn                 =  11,              /*!< 11 RTC0                                                                   */
  TEMP_IRQn                 =  12,              /*!< 12 TEMP                                                                   */
  RNG_IRQn                  =  13,              /*!< 13 RNG                                                                    */
  ECB_IRQn                  =  14,              /*!< 14 ECB                                                                    */
  CCM_AAR_IRQn              =  15,              /*!< 15 CCM_AAR                                                                */
  WDT_IRQn                  =  16,              /*!< 16 WDT                                                                    */
  RTC1_IRQn                 =  17,              /*!< 17 RTC1                                                                   */
  QDEC_IRQn                 =  18,              /*!< 18 QDEC                                                                   */
  COMP_LPCOMP_IRQn          =  19,              /*!< 19 COMP_LPCOMP                                                            */
  SWI0_EGU0_IRQn            =  20,              /*!< 20 SWI0_EGU0                                                              */
  SWI1_EGU1_IRQn            =  21,              /*!< 21 SWI1_EGU1                                                              */
  SWI2_EGU2_IRQn            =  22,              /*!< 22 SWI2_EGU2                                                              */
  SWI3_EGU3_IRQn            =  23,              /*!< 23 SWI3_EGU3                                                              */
  SWI4_EGU4_IRQn            =  24,              /*!< 24 SWI4_EGU4                                                              */
  SWI5_EGU5_IRQn            =  25,              /*!< 25 SWI5_EGU5                                                              */
  TIMER3_IRQn               =  26,              /*!< 26 TIMER3                                                                 */
  TIMER4_IRQn               =  27,              /*!< 27 TIMER4                                                                 */
  PWM0_IRQn                 =  28,              /*!< 28 PWM0                                                                   */
  PDM_IRQn                  =  29,              /*!< 29 PDM                                                                    */
  MWU_IRQn                  =  32,              /*!< 32 MWU                                                                    */
  PWM1_IRQn                 =  33,              /*!< 33 PWM1                                                                   */
  PWM2_IRQn                 =  34,              /*!< 34 PWM2                                                                   */
  SPIM2_SPIS2_SPI2_IRQn     =  35,              /*!< 35 SPIM2_SPIS2_SPI2                                                       */
  RTC2_IRQn                 =  36,              /*!< 36 RTC2                                                                   */
  I2S_IRQn                  =  37,              /*!< 37 I2S                                                                    */
  FPU_IRQn                  =  38,              /*!< 38 FPU                                                                    */
  USBD_IRQn                 =  39,              /*!< 39 USBD                                                                   */
  UARTE1_IRQn               =  40,              /*!< 40 UARTE1                                                                 */
  PWM3_IRQn                 =  45,              /*!< 45 PWM3                                                                   */
  SPIM3_IRQn                =  47               /*!< 47 SPIM3                                                                  */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ===========================  Configuration of the ARM Cortex-M4 Processor and Core Peripherals  =========================== */
#define __CM4_REV                 0x0001U       /*!< CM4 Core Revision                                                         */
#define __INTERRUPTS_MAX                   112        /*!< Top interrupt number                                                      */
#define __DSP_PRESENT                  1        /*!< DSP present or not                                                        */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  1        /*!< FPU present                                                               */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm4.h"                           /*!< ARM Cortex-M4 processor and core peripherals                              */
#include "system_nrf52833.h"                    /*!< nrf52833 System                                                           */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* ========================================  Start of section using anonymous unions  ======================================== */
#if defined (__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined (__ICCARM__)
  #pragma language=extended
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic push
  #pragma clang diagnostic ignored "-Wc11-extensions"
  #pragma clang diagnostic ignored "-Wreserved-id-macro"
  #pragma clang diagnostic ignored "-Wgnu-anonymous-struct"
  #pragma clang diagnostic ignored "-Wnested-anon-types"
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning 586
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#else
  #warning Not supported compiler type
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief FICR_INFO [INFO] (Device info)
  */
typedef struct {
  __IM  uint32_t  PART;                         /*!< Part code                                                                 */
  __IM  uint32_t  VARIANT;                      /*!< Build code (hardware version and production configuration)                */
  __IM  uint32_t  PACKAGE;                      /*!< Package option                                                            */
  __IM  uint32_t  RAM;                          /*!< RAM variant                                                               */
  __IM  uint32_t  FLASH;                        /*!< Flash variant                                                             */
} FICR_INFO_Type;                               /*!< Size = 20 (0x14)                                                          */


/**
  * @brief FICR_TEMP [TEMP] (Registers storing factory TEMP module linearization coefficients)
  */
typedef struct {
  __IM  uint32_t  A0;                           /*!< Slope definition A0                                                       */
  __IM  uint32_t  A1;                           /*!< Slope definition A1                                                       */
  __IM  uint32_t  A2;                           /*!< Slope definition A2                                                       */
  __IM  uint32_t  A3;                           /*!< Slope definition A3                                                       */
  __IM  uint32_t  A4;                           /*!< Slope definition A4                                                       */
  __IM  uint32_t  A5;                           /*!< Slope definition A5                                                       */
  __IM  uint32_t  B0;                           /*!< Y-intercept B0                                                            */
  __IM  uint32_t  B1;                           /*!< Y-intercept B1                                                            */
  __IM  uint32_t  B2;                           /*!< Y-intercept B2                                                            */
  __IM  uint32_t  B3;                           /*!< Y-intercept B3                                                            */
  __IM  uint32_t  B4;                           /*!< Y-intercept B4                                                            */
  __IM  uint32_t  B5;                           /*!< Y-intercept B5                                                            */
  __IM  uint32_t  T0;                           /*!< Segment end T0                                                            */
  __IM  uint32_t  T1;                           /*!< Segment end T1                                                            */
  __IM  uint32_t  T2;                           /*!< Segment end T2                                                            */
  __IM  uint32_t  T3;                           /*!< Segment end T3                                                            */
  __IM  uint32_t  T4;                           /*!< Segment end T4                                                            */
} FICR_TEMP_Type;                               /*!< Size = 68 (0x44)                                                          */


/**
  * @brief FICR_NFC [NFC] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  TAGHEADER0;                   /*!< Default header for NFC tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST, and NFCID1_LAST.               */
  __IM  uint32_t  TAGHEADER1;                   /*!< Default header for NFC tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST, and NFCID1_LAST.               */
  __IM  uint32_t  TAGHEADER2;                   /*!< Default header for NFC tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST, and NFCID1_LAST.               */
  __IM  uint32_t  TAGHEADER3;                   /*!< Default header for NFC tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST, and NFCID1_LAST.               */
} FICR_NFC_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief POWER_RAM [RAM] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  POWER;                        /*!< Description cluster: RAMn power control register                          */
  __OM  uint32_t  POWERSET;                     /*!< Description cluster: RAMn power control set register                      */
  __OM  uint32_t  POWERCLR;                     /*!< Description cluster: RAMn power control clear register                    */
  __IM  uint32_t  RESERVED;
} POWER_RAM_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief RADIO_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DFEGPIO[8];                   /*!< Description collection: Pin select for DFE pin n                          */
} RADIO_PSEL_Type;                              /*!< Size = 32 (0x20)                                                          */


/**
  * @brief RADIO_DFEPACKET [DFEPACKET] (DFE packet EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of buffer words to transfer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of samples transferred in the last transaction                     */
} RADIO_DFEPACKET_Type;                         /*!< Size = 12 (0xc)                                                           */


/**
  * @brief UART_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RTS;                          /*!< Pin select for RTS                                                        */
  __IOM uint32_t  TXD;                          /*!< Pin select for TXD                                                        */
  __IOM uint32_t  CTS;                          /*!< Pin select for CTS                                                        */
  __IOM uint32_t  RXD;                          /*!< Pin select for RXD                                                        */
} UART_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RTS;                          /*!< Pin select for RTS signal                                                 */
  __IOM uint32_t  TXD;                          /*!< Pin select for TXD signal                                                 */
  __IOM uint32_t  CTS;                          /*!< Pin select for CTS signal                                                 */
  __IOM uint32_t  RXD;                          /*!< Pin select for RXD signal                                                 */
} UARTE_PSEL_Type;                              /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_RXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief UARTE_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_TXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief SPI_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
} SPI_PSEL_Type;                                /*!< Size = 12 (0xc)                                                           */


/**
  * @brief SPIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN                                                        */
} SPIM_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Number of bytes in transmit buffer                                        */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_IFTIMING [IFTIMING] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RXDELAY;                      /*!< Sample delay for input serial data on MISO                                */
  __IOM uint32_t  CSNDUR;                       /*!< Minimum duration between edge of CSN and edge of SCK and minimum
                                                     duration CSN must stay high between transactions                          */
} SPIM_IFTIMING_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN signal                                                 */
} SPIS_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes received in last granted transaction                      */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transmitted in last granted transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWI_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL                                                        */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA                                                        */
} TWI_PSEL_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIM_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIS_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIS_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in RXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last RXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in TXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last TXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief NFCT_FRAMESTATUS [FRAMESTATUS] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RX;                           /*!< Result of last incoming frame                                             */
} NFCT_FRAMESTATUS_Type;                        /*!< Size = 4 (0x4)                                                            */


/**
  * @brief NFCT_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  FRAMECONFIG;                  /*!< Configuration of outgoing frames                                          */
  __IOM uint32_t  AMOUNT;                       /*!< Size of outgoing frame                                                    */
} NFCT_TXD_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief NFCT_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  FRAMECONFIG;                  /*!< Configuration of incoming frames                                          */
  __IM  uint32_t  AMOUNT;                       /*!< Size of last incoming frame                                               */
} NFCT_RXD_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_EVENTS_CH [EVENTS_CH] (Peripheral events.)
  */
typedef struct {
  __IOM uint32_t  LIMITH;                       /*!< Description cluster: Last result is equal or above CH[n].LIMIT.HIGH       */
  __IOM uint32_t  LIMITL;                       /*!< Description cluster: Last result is equal or below CH[n].LIMIT.LOW        */
} SAADC_EVENTS_CH_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_CH [CH] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PSELP;                        /*!< Description cluster: Input positive pin selection for CH[n]               */
  __IOM uint32_t  PSELN;                        /*!< Description cluster: Input negative pin selection for CH[n]               */
  __IOM uint32_t  CONFIG;                       /*!< Description cluster: Input configuration for CH[n]                        */
  __IOM uint32_t  LIMIT;                        /*!< Description cluster: High/low limits for event monitoring of
                                                     a channel                                                                 */
} SAADC_CH_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SAADC_RESULT [RESULT] (RESULT EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of 16-bit samples to be written to output RAM
                                                     buffer                                                                    */
  __IM  uint32_t  AMOUNT;                       /*!< Number of 16-bit samples written to output RAM buffer since
                                                     the previous START task                                                   */
} SAADC_RESULT_Type;                            /*!< Size = 12 (0xc)                                                           */


/**
  * @brief QDEC_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LED;                          /*!< Pin select for LED signal                                                 */
  __IOM uint32_t  A;                            /*!< Pin select for A signal                                                   */
  __IOM uint32_t  B;                            /*!< Pin select for B signal                                                   */
} QDEC_PSEL_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief PWM_SEQ [SEQ] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Beginning address in RAM of this sequence            */
  __IOM uint32_t  CNT;                          /*!< Description cluster: Number of values (duty cycles) in this
                                                     sequence                                                                  */
  __IOM uint32_t  REFRESH;                      /*!< Description cluster: Number of additional PWM periods between
                                                     samples loaded into compare register                                      */
  __IOM uint32_t  ENDDELAY;                     /*!< Description cluster: Time added after the sequence                        */
  __IM  uint32_t  RESERVED[4];
} PWM_SEQ_Type;                                 /*!< Size = 32 (0x20)                                                          */


/**
  * @brief PWM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  OUT[4];                       /*!< Description collection: Output pin select for PWM channel n               */
} PWM_PSEL_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief PDM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  CLK;                          /*!< Pin number configuration for PDM CLK signal                               */
  __IOM uint32_t  DIN;                          /*!< Pin number configuration for PDM DIN signal                               */
} PDM_PSEL_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PDM_SAMPLE [SAMPLE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RAM address pointer to write samples to with EasyDMA                      */
  __IOM uint32_t  MAXCNT;                       /*!< Number of samples to allocate memory for in EasyDMA mode                  */
} PDM_SAMPLE_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief ACL_ACL [ACL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  ADDR;                         /*!< Description cluster: Start address of region to protect. The
                                                     start address must be word-aligned.                                       */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Size of region to protect counting from
                                                     address ACL[n].ADDR. Writing a '0' has no effect.                         */
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for region n as defined
                                                     by start address ACL[n].ADDR and size ACL[n].SIZE                         */
  __IM  uint32_t  RESERVED;
} ACL_ACL_Type;                                 /*!< Size = 16 (0x10)                                                          */


/**
  * @brief PPI_TASKS_CHG [TASKS_CHG] (Channel group tasks)
  */
typedef struct {
  __OM  uint32_t  EN;                           /*!< Description cluster: Enable channel group n                               */
  __OM  uint32_t  DIS;                          /*!< Description cluster: Disable channel group n                              */
} PPI_TASKS_CHG_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PPI_CH [CH] (PPI Channel)
  */
typedef struct {
  __IOM uint32_t  EEP;                          /*!< Description cluster: Channel n event endpoint                             */
  __IOM uint32_t  TEP;                          /*!< Description cluster: Channel n task endpoint                              */
} PPI_CH_Type;                                  /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PPI_FORK [FORK] (Fork)
  */
typedef struct {
  __IOM uint32_t  TEP;                          /*!< Description cluster: Channel n task endpoint                              */
} PPI_FORK_Type;                                /*!< Size = 4 (0x4)                                                            */


/**
  * @brief MWU_EVENTS_REGION [EVENTS_REGION] (Peripheral events.)
  */
typedef struct {
  __IOM uint32_t  WA;                           /*!< Description cluster: Write access to region n detected                    */
  __IOM uint32_t  RA;                           /*!< Description cluster: Read access to region n detected                     */
} MWU_EVENTS_REGION_Type;                       /*!< Size = 8 (0x8)                                                            */


/**
  * @brief MWU_EVENTS_PREGION [EVENTS_PREGION] (Peripheral events.)
  */
typedef struct {
  __IOM uint32_t  WA;                           /*!< Description cluster: Write access to peripheral region n detected         */
  __IOM uint32_t  RA;                           /*!< Description cluster: Read access to peripheral region n detected          */
} MWU_EVENTS_PREGION_Type;                      /*!< Size = 8 (0x8)                                                            */


/**
  * @brief MWU_PERREGION [PERREGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SUBSTATWA;                    /*!< Description cluster: Source of event/interrupt in region n,
                                                     write access detected while corresponding subregion was
                                                     enabled for watching                                                      */
  __IOM uint32_t  SUBSTATRA;                    /*!< Description cluster: Source of event/interrupt in region n,
                                                     read access detected while corresponding subregion was
                                                     enabled for watching                                                      */
} MWU_PERREGION_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief MWU_REGION [REGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  START;                        /*!< Description cluster: Start address for region n                           */
  __IOM uint32_t  END;                          /*!< Description cluster: End address of region n                              */
  __IM  uint32_t  RESERVED[2];
} MWU_REGION_Type;                              /*!< Size = 16 (0x10)                                                          */


/**
  * @brief MWU_PREGION [PREGION] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  START;                        /*!< Description cluster: Reserved for future use                              */
  __IM  uint32_t  END;                          /*!< Description cluster: Reserved for future use                              */
  __IOM uint32_t  SUBS;                         /*!< Description cluster: Subregions of region n                               */
  __IM  uint32_t  RESERVED;
} MWU_PREGION_Type;                             /*!< Size = 16 (0x10)                                                          */


/**
  * @brief I2S_CONFIG [CONFIG] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MODE;                         /*!< I2S mode.                                                                 */
  __IOM uint32_t  RXEN;                         /*!< Reception (RX) enable.                                                    */
  __IOM uint32_t  TXEN;                         /*!< Transmission (TX) enable.                                                 */
  __IOM uint32_t  MCKEN;                        /*!< Master clock generator enable.                                            */
  __IOM uint32_t  MCKFREQ;                      /*!< Master clock generator frequency.                                         */
  __IOM uint32_t  RATIO;                        /*!< MCK / LRCK ratio.                                                         */
  __IOM uint32_t  SWIDTH;                       /*!< Sample width.                                                             */
  __IOM uint32_t  ALIGN;                        /*!< Alignment of sample within a frame.                                       */
  __IOM uint32_t  FORMAT;                       /*!< Frame format.                                                             */
  __IOM uint32_t  CHANNELS;                     /*!< Enable channels.                                                          */
} I2S_CONFIG_Type;                              /*!< Size = 40 (0x28)                                                          */


/**
  * @brief I2S_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Receive buffer RAM start address.                                         */
} I2S_RXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Transmit buffer RAM start address.                                        */
} I2S_TXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_RXTXD [RXTXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MAXCNT;                       /*!< Size of RXD and TXD buffers.                                              */
} I2S_RXTXD_Type;                               /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MCK;                          /*!< Pin select for MCK signal.                                                */
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK signal.                                                */
  __IOM uint32_t  LRCK;                         /*!< Pin select for LRCK signal.                                               */
  __IOM uint32_t  SDIN;                         /*!< Pin select for SDIN signal.                                               */
  __IOM uint32_t  SDOUT;                        /*!< Pin select for SDOUT signal.                                              */
} I2S_PSEL_Type;                                /*!< Size = 20 (0x14)                                                          */


/**
  * @brief USBD_HALTED [HALTED] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  EPIN[8];                      /*!< Description collection: IN endpoint halted status. Can be used
                                                     as is as response to a GetStatus() request to endpoint.                   */
  __IM  uint32_t  RESERVED;
  __IM  uint32_t  EPOUT[8];                     /*!< Description collection: OUT endpoint halted status. Can be used
                                                     as is as response to a GetStatus() request to endpoint.                   */
} USBD_HALTED_Type;                             /*!< Size = 68 (0x44)                                                          */


/**
  * @brief USBD_SIZE [SIZE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  EPOUT[8];                     /*!< Description collection: Number of bytes received last in the
                                                     data stage of this OUT endpoint                                           */
  __IM  uint32_t  ISOOUT;                       /*!< Number of bytes received last on this ISO OUT data endpoint               */
} USBD_SIZE_Type;                               /*!< Size = 36 (0x24)                                                          */


/**
  * @brief USBD_EPIN [EPIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Data pointer                                         */
  __IOM uint32_t  MAXCNT;                       /*!< Description cluster: Maximum number of bytes to transfer                  */
  __IM  uint32_t  AMOUNT;                       /*!< Description cluster: Number of bytes transferred in the last
                                                     transaction                                                               */
  __IM  uint32_t  RESERVED[2];
} USBD_EPIN_Type;                               /*!< Size = 20 (0x14)                                                          */


/**
  * @brief USBD_ISOIN [ISOIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes to transfer                                       */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} USBD_ISOIN_Type;                              /*!< Size = 12 (0xc)                                                           */


/**
  * @brief USBD_EPOUT [EPOUT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Data pointer                                         */
  __IOM uint32_t  MAXCNT;                       /*!< Description cluster: Maximum number of bytes to transfer                  */
  __IM  uint32_t  AMOUNT;                       /*!< Description cluster: Number of bytes transferred in the last
                                                     transaction                                                               */
  __IM  uint32_t  RESERVED[2];
} USBD_EPOUT_Type;                              /*!< Size = 20 (0x14)                                                          */


/**
  * @brief USBD_ISOOUT [ISOOUT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes to transfer                                       */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} USBD_ISOOUT_Type;                             /*!< Size = 12 (0xc)                                                           */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                           FICR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Factory information configuration registers (FICR)
  */

typedef struct {                                /*!< FICR Structure                                                            */
  __IM  uint32_t  RESERVED[4];
  __IM  uint32_t  CODEPAGESIZE;                 /*!< Code memory page size                                                     */
  __IM  uint32_t  CODESIZE;                     /*!< Code memory size                                                          */
  __IM  uint32_t  RESERVED1[18];
  __IM  uint32_t  DEVICEID[2];                  /*!< Description collection: Device identifier                                 */
  __IM  uint32_t  RESERVED2[6];
  __IM  uint32_t  ER[4];                        /*!< Description collection: Encryption root, word n                           */
  __IM  uint32_t  IR[4];                        /*!< Description collection: Identity Root, word n                             */
  __IM  uint32_t  DEVICEADDRTYPE;               /*!< Device address type                                                       */
  __IM  uint32_t  DEVICEADDR[2];                /*!< Description collection: Device address n                                  */
  __IM  uint32_t  RESERVED3[21];
  __IM  FICR_INFO_Type INFO;                    /*!< Device info                                                               */
  __IM  uint32_t  RESERVED4[143];
  __IM  uint32_t  PRODTEST[3];                  /*!< Description collection: Production test signature n                       */
  __IM  uint32_t  RESERVED5[42];
  __IM  FICR_TEMP_Type TEMP;                    /*!< Registers storing factory TEMP module linearization coefficients          */
  __IM  uint32_t  RESERVED6[2];
  __IOM FICR_NFC_Type NFC;                      /*!< Unspecified                                                               */
} NRF_FICR_Type;                                /*!< Size = 1120 (0x460)                                                       */



/* =========================================================================================================================== */
/* ================                                           UICR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief User information configuration registers (UICR)
  */

typedef struct {                                /*!< UICR Structure                                                            */
  __IM  uint32_t  RESERVED[5];
  __IOM uint32_t  NRFFW[13];                    /*!< Description collection: Reserved for Nordic firmware design               */
  __IM  uint32_t  RESERVED1[2];
  __IOM uint32_t  NRFHW[12];                    /*!< Description collection: Reserved for Nordic hardware design               */
  __IOM uint32_t  CUSTOMER[32];                 /*!< Description collection: Reserved for customer                             */
  __IM  uint32_t  RESERVED2[64];
  __IOM uint32_t  PSELRESET[2];                 /*!< Description collection: Mapping of the nRESET function (see
                                                     POWER chapter for details)                                                */
  __IOM uint32_t  APPROTECT;                    /*!< Access port protection                                                    */
  __IOM uint32_t  NFCPINS;                      /*!< Setting of pins dedicated to NFC functionality: NFC antenna
                                                     or GPIO                                                                   */
  __IOM uint32_t  DEBUGCTRL;                    /*!< Processor debug control                                                   */
  __IM  uint32_t  RESERVED3[60];
  __IOM uint32_t  REGOUT0;                      /*!< Output voltage from REG0 regulator stage. The maximum output
                                                     voltage from this stage is given as VDDH - V_VDDH-VDD.                    */
} NRF_UICR_Type;                                /*!< Size = 776 (0x308)                                                        */



/* =========================================================================================================================== */
/* ================                                         APPROTECT                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Access Port Protection (APPROTECT)
  */

typedef struct {                                /*!< APPROTECT Structure                                                       */
  __IM  uint32_t  RESERVED[340];
  __IOM uint32_t  FORCEPROTECT;                 /*!< Software force enable APPROTECT mechanism until next reset.               */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  DISABLE;                      /*!< Software disable APPROTECT mechanism                                      */
} NRF_APPROTECT_Type;                           /*!< Size = 1372 (0x55c)                                                       */



/* =========================================================================================================================== */
/* ================                                           CLOCK                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock control (CLOCK)
  */

typedef struct {                                /*!< CLOCK Structure                                                           */
  __OM  uint32_t  TASKS_HFCLKSTART;             /*!< Start HFXO crystal oscillator                                             */
  __OM  uint32_t  TASKS_HFCLKSTOP;              /*!< Stop HFXO crystal oscillator                                              */
  __OM  uint32_t  TASKS_LFCLKSTART;             /*!< Start LFCLK                                                               */
  __OM  uint32_t  TASKS_LFCLKSTOP;              /*!< Stop LFCLK                                                                */
  __OM  uint32_t  TASKS_CAL;                    /*!< Start calibration of LFRC                                                 */
  __OM  uint32_t  TASKS_CTSTART;                /*!< Start calibration timer                                                   */
  __OM  uint32_t  TASKS_CTSTOP;                 /*!< Stop calibration timer                                                    */
  __IM  uint32_t  RESERVED[57];
  __IOM uint32_t  EVENTS_HFCLKSTARTED;          /*!< HFXO crystal oscillator started                                           */
  __IOM uint32_t  EVENTS_LFCLKSTARTED;          /*!< LFCLK started                                                             */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  EVENTS_DONE;                  /*!< Calibration of LFRC completed                                             */
  __IOM uint32_t  EVENTS_CTTO;                  /*!< Calibration timer timeout                                                 */
  __IM  uint32_t  RESERVED2[5];
  __IOM uint32_t  EVENTS_CTSTARTED;             /*!< Calibration timer has been started and is ready to process new
                                                     tasks                                                                     */
  __IOM uint32_t  EVENTS_CTSTOPPED;             /*!< Calibration timer has been stopped and is ready to process new
                                                     tasks                                                                     */
  __IM  uint32_t  RESERVED3[117];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[63];
  __IM  uint32_t  HFCLKRUN;                     /*!< Status indicating that HFCLKSTART task has been triggered                 */
  __IM  uint32_t  HFCLKSTAT;                    /*!< HFCLK status                                                              */
  __IM  uint32_t  RESERVED5;
  __IM  uint32_t  LFCLKRUN;                     /*!< Status indicating that LFCLKSTART task has been triggered                 */
  __IM  uint32_t  LFCLKSTAT;                    /*!< LFCLK status                                                              */
  __IM  uint32_t  LFCLKSRCCOPY;                 /*!< Copy of LFCLKSRC register, set when LFCLKSTART task was triggered         */
  __IM  uint32_t  RESERVED6[62];
  __IOM uint32_t  LFCLKSRC;                     /*!< Clock source for the LFCLK                                                */
  __IM  uint32_t  RESERVED7[3];
  __IOM uint32_t  HFXODEBOUNCE;                 /*!< HFXO debounce time. The HFXO is started by triggering the TASKS_HFCLKSTART
                                                     task.                                                                     */
  __IOM uint32_t  LFXODEBOUNCE;                 /*!< LFXO debounce time. The LFXO is started by triggering the TASKS_LFCLKSTART
                                                     task when the LFCLKSRC register is configured for Xtal.                   */
  __IM  uint32_t  RESERVED8[2];
  __IOM uint32_t  CTIV;                         /*!< Calibration timer interval                                                */
  __IM  uint32_t  RESERVED9[8];
  __IOM uint32_t  TRACECONFIG;                  /*!< Clocking options for the trace port debug interface                       */
} NRF_CLOCK_Type;                               /*!< Size = 1376 (0x560)                                                       */



/* =========================================================================================================================== */
/* ================                                           POWER                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Power control (POWER)
  */

typedef struct {                                /*!< POWER Structure                                                           */
  __IM  uint32_t  RESERVED[30];
  __OM  uint32_t  TASKS_CONSTLAT;               /*!< Enable Constant Latency mode                                              */
  __OM  uint32_t  TASKS_LOWPWR;                 /*!< Enable Low-power mode (variable latency)                                  */
  __IM  uint32_t  RESERVED1[34];
  __IOM uint32_t  EVENTS_POFWARN;               /*!< Power failure warning                                                     */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_SLEEPENTER;            /*!< CPU entered WFI/WFE sleep                                                 */
  __IOM uint32_t  EVENTS_SLEEPEXIT;             /*!< CPU exited WFI/WFE sleep                                                  */
  __IOM uint32_t  EVENTS_USBDETECTED;           /*!< Voltage supply detected on VBUS                                           */
  __IOM uint32_t  EVENTS_USBREMOVED;            /*!< Voltage supply removed from VBUS                                          */
  __IOM uint32_t  EVENTS_USBPWRRDY;             /*!< USB 3.3 V supply ready                                                    */
  __IM  uint32_t  RESERVED3[119];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[61];
  __IOM uint32_t  RESETREAS;                    /*!< Reset reason                                                              */
  __IM  uint32_t  RESERVED5[9];
  __IM  uint32_t  RAMSTATUS;                    /*!< Deprecated register - RAM status register                                 */
  __IM  uint32_t  RESERVED6[3];
  __IM  uint32_t  USBREGSTATUS;                 /*!< USB supply status                                                         */
  __IM  uint32_t  RESERVED7[49];
  __OM  uint32_t  SYSTEMOFF;                    /*!< System OFF register                                                       */
  __IM  uint32_t  RESERVED8[3];
  __IOM uint32_t  POFCON;                       /*!< Power-fail comparator configuration                                       */
  __IM  uint32_t  RESERVED9[2];
  __IOM uint32_t  GPREGRET;                     /*!< General purpose retention register                                        */
  __IOM uint32_t  GPREGRET2;                    /*!< General purpose retention register                                        */
  __IM  uint32_t  RESERVED10[21];
  __IOM uint32_t  DCDCEN;                       /*!< Enable DC/DC converter for REG1 stage                                     */
  __IM  uint32_t  RESERVED11[49];
  __IM  uint32_t  MAINREGSTATUS;                /*!< Main supply status                                                        */
  __IM  uint32_t  RESERVED12[175];
  __IOM POWER_RAM_Type RAM[9];                  /*!< Unspecified                                                               */
} NRF_POWER_Type;                               /*!< Size = 2448 (0x990)                                                       */



/* =========================================================================================================================== */
/* ================                                            P0                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Port 1 (P0)
  */

typedef struct {                                /*!< P0 Structure                                                              */
  __IM  uint32_t  RESERVED[321];
  __IOM uint32_t  OUT;                          /*!< Write GPIO port                                                           */
  __IOM uint32_t  OUTSET;                       /*!< Set individual bits in GPIO port                                          */
  __IOM uint32_t  OUTCLR;                       /*!< Clear individual bits in GPIO port                                        */
  __IM  uint32_t  IN;                           /*!< Read GPIO port                                                            */
  __IOM uint32_t  DIR;                          /*!< Direction of GPIO pins                                                    */
  __IOM uint32_t  DIRSET;                       /*!< DIR set register                                                          */
  __IOM uint32_t  DIRCLR;                       /*!< DIR clear register                                                        */
  __IOM uint32_t  LATCH;                        /*!< Latch register indicating what GPIO pins that have met the criteria
                                                     set in the PIN_CNF[n].SENSE registers                                     */
  __IOM uint32_t  DETECTMODE;                   /*!< Select between default DETECT signal behavior and LDETECT mode            */
  __IM  uint32_t  RESERVED1[118];
  __IOM uint32_t  PIN_CNF[32];                  /*!< Description collection: Configuration of GPIO pins                        */
} NRF_GPIO_Type;                                /*!< Size = 1920 (0x780)                                                       */



/* =========================================================================================================================== */
/* ================                                           RADIO                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief 2.4 GHz radio (RADIO)
  */

typedef struct {                                /*!< RADIO Structure                                                           */
  __OM  uint32_t  TASKS_TXEN;                   /*!< Enable RADIO in TX mode                                                   */
  __OM  uint32_t  TASKS_RXEN;                   /*!< Enable RADIO in RX mode                                                   */
  __OM  uint32_t  TASKS_START;                  /*!< Start RADIO                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RADIO                                                                */
  __OM  uint32_t  TASKS_DISABLE;                /*!< Disable RADIO                                                             */
  __OM  uint32_t  TASKS_RSSISTART;              /*!< Start the RSSI and take one single sample of the receive signal
                                                     strength                                                                  */
  __OM  uint32_t  TASKS_RSSISTOP;               /*!< Stop the RSSI measurement                                                 */
  __OM  uint32_t  TASKS_BCSTART;                /*!< Start the bit counter                                                     */
  __OM  uint32_t  TASKS_BCSTOP;                 /*!< Stop the bit counter                                                      */
  __OM  uint32_t  TASKS_EDSTART;                /*!< Start the energy detect measurement used in IEEE 802.15.4 mode            */
  __OM  uint32_t  TASKS_EDSTOP;                 /*!< Stop the energy detect measurement                                        */
  __OM  uint32_t  TASKS_CCASTART;               /*!< Start the clear channel assessment used in IEEE 802.15.4 mode             */
  __OM  uint32_t  TASKS_CCASTOP;                /*!< Stop the clear channel assessment                                         */
  __IM  uint32_t  RESERVED[51];
  __IOM uint32_t  EVENTS_READY;                 /*!< RADIO has ramped up and is ready to be started                            */
  __IOM uint32_t  EVENTS_ADDRESS;               /*!< Address sent or received                                                  */
  __IOM uint32_t  EVENTS_PAYLOAD;               /*!< Packet payload sent or received                                           */
  __IOM uint32_t  EVENTS_END;                   /*!< Packet sent or received                                                   */
  __IOM uint32_t  EVENTS_DISABLED;              /*!< RADIO has been disabled                                                   */
  __IOM uint32_t  EVENTS_DEVMATCH;              /*!< A device address match occurred on the last received packet               */
  __IOM uint32_t  EVENTS_DEVMISS;               /*!< No device address match occurred on the last received packet              */
  __IOM uint32_t  EVENTS_RSSIEND;               /*!< Sampling of receive signal strength complete                              */
  __IM  uint32_t  RESERVED1[2];
  __IOM uint32_t  EVENTS_BCMATCH;               /*!< Bit counter reached bit count value                                       */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  EVENTS_CRCOK;                 /*!< Packet received with CRC ok                                               */
  __IOM uint32_t  EVENTS_CRCERROR;              /*!< Packet received with CRC error                                            */
  __IOM uint32_t  EVENTS_FRAMESTART;            /*!< IEEE 802.15.4 length field received                                       */
  __IOM uint32_t  EVENTS_EDEND;                 /*!< Sampling of energy detection complete. A new ED sample is ready
                                                     for readout from the RADIO.EDSAMPLE register.                             */
  __IOM uint32_t  EVENTS_EDSTOPPED;             /*!< The sampling of energy detection has stopped                              */
  __IOM uint32_t  EVENTS_CCAIDLE;               /*!< Wireless medium in idle - clear to send                                   */
  __IOM uint32_t  EVENTS_CCABUSY;               /*!< Wireless medium busy - do not send                                        */
  __IOM uint32_t  EVENTS_CCASTOPPED;            /*!< The CCA has stopped                                                       */
  __IOM uint32_t  EVENTS_RATEBOOST;             /*!< Ble_LR CI field received, receive mode is changed from Ble_LR125Kbit
                                                     to Ble_LR500Kbit.                                                         */
  __IOM uint32_t  EVENTS_TXREADY;               /*!< RADIO has ramped up and is ready to be started TX path                    */
  __IOM uint32_t  EVENTS_RXREADY;               /*!< RADIO has ramped up and is ready to be started RX path                    */
  __IOM uint32_t  EVENTS_MHRMATCH;              /*!< MAC header match found                                                    */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_SYNC;                  /*!< Preamble indicator                                                        */
  __IOM uint32_t  EVENTS_PHYEND;                /*!< Generated when last bit is sent on air, or received from air              */
  __IOM uint32_t  EVENTS_CTEPRESENT;            /*!< CTE is present (early warning right after receiving CTEInfo
                                                     byte)                                                                     */
  __IM  uint32_t  RESERVED4[35];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED5[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[61];
  __IM  uint32_t  CRCSTATUS;                    /*!< CRC status                                                                */
  __IM  uint32_t  RESERVED7;
  __IM  uint32_t  RXMATCH;                      /*!< Received address                                                          */
  __IM  uint32_t  RXCRC;                        /*!< CRC field of previously received packet                                   */
  __IM  uint32_t  DAI;                          /*!< Device address match index                                                */
  __IM  uint32_t  PDUSTAT;                      /*!< Payload status                                                            */
  __IM  uint32_t  RESERVED8[13];
  __IM  uint32_t  CTESTATUS;                    /*!< CTEInfo parsed from received packet                                       */
  __IM  uint32_t  RESERVED9[2];
  __IM  uint32_t  DFESTATUS;                    /*!< DFE status information                                                    */
  __IM  uint32_t  RESERVED10[42];
  __IOM uint32_t  PACKETPTR;                    /*!< Packet pointer                                                            */
  __IOM uint32_t  FREQUENCY;                    /*!< Frequency                                                                 */
  __IOM uint32_t  TXPOWER;                      /*!< Output power                                                              */
  __IOM uint32_t  MODE;                         /*!< Data rate and modulation                                                  */
  __IOM uint32_t  PCNF0;                        /*!< Packet configuration register 0                                           */
  __IOM uint32_t  PCNF1;                        /*!< Packet configuration register 1                                           */
  __IOM uint32_t  BASE0;                        /*!< Base address 0                                                            */
  __IOM uint32_t  BASE1;                        /*!< Base address 1                                                            */
  __IOM uint32_t  PREFIX0;                      /*!< Prefixes bytes for logical addresses 0-3                                  */
  __IOM uint32_t  PREFIX1;                      /*!< Prefixes bytes for logical addresses 4-7                                  */
  __IOM uint32_t  TXADDRESS;                    /*!< Transmit address select                                                   */
  __IOM uint32_t  RXADDRESSES;                  /*!< Receive address select                                                    */
  __IOM uint32_t  CRCCNF;                       /*!< CRC configuration                                                         */
  __IOM uint32_t  CRCPOLY;                      /*!< CRC polynomial                                                            */
  __IOM uint32_t  CRCINIT;                      /*!< CRC initial value                                                         */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  TIFS;                         /*!< Interframe spacing in us                                                  */
  __IM  uint32_t  RSSISAMPLE;                   /*!< RSSI sample                                                               */
  __IM  uint32_t  RESERVED12;
  __IM  uint32_t  STATE;                        /*!< Current radio state                                                       */
  __IOM uint32_t  DATAWHITEIV;                  /*!< Data whitening initial value                                              */
  __IM  uint32_t  RESERVED13[2];
  __IOM uint32_t  BCC;                          /*!< Bit counter compare                                                       */
  __IM  uint32_t  RESERVED14[39];
  __IOM uint32_t  DAB[8];                       /*!< Description collection: Device address base segment n                     */
  __IOM uint32_t  DAP[8];                       /*!< Description collection: Device address prefix n                           */
  __IOM uint32_t  DACNF;                        /*!< Device address match configuration                                        */
  __IOM uint32_t  MHRMATCHCONF;                 /*!< Search pattern configuration                                              */
  __IOM uint32_t  MHRMATCHMAS;                  /*!< Pattern mask                                                              */
  __IM  uint32_t  RESERVED15;
  __IOM uint32_t  MODECNF0;                     /*!< Radio mode configuration register 0                                       */
  __IM  uint32_t  RESERVED16[3];
  __IOM uint32_t  SFD;                          /*!< IEEE 802.15.4 start of frame delimiter                                    */
  __IOM uint32_t  EDCNT;                        /*!< IEEE 802.15.4 energy detect loop count                                    */
  __IM  uint32_t  EDSAMPLE;                     /*!< IEEE 802.15.4 energy detect level                                         */
  __IOM uint32_t  CCACTRL;                      /*!< IEEE 802.15.4 clear channel assessment control                            */
  __IM  uint32_t  RESERVED17[164];
  __IOM uint32_t  DFEMODE;                      /*!< Whether to use Angle-of-Arrival (AOA) or Angle-of-Departure
                                                     (AOD)                                                                     */
  __IOM uint32_t  CTEINLINECONF;                /*!< Configuration for CTE inline mode                                         */
  __IM  uint32_t  RESERVED18[2];
  __IOM uint32_t  DFECTRL1;                     /*!< Various configuration for Direction finding                               */
  __IOM uint32_t  DFECTRL2;                     /*!< Start offset for Direction finding                                        */
  __IM  uint32_t  RESERVED19[4];
  __IOM uint32_t  SWITCHPATTERN;                /*!< GPIO patterns to be used for each antenna                                 */
  __IOM uint32_t  CLEARPATTERN;                 /*!< Clear the GPIO pattern array for antenna control                          */
  __IOM RADIO_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IOM RADIO_DFEPACKET_Type DFEPACKET;         /*!< DFE packet EasyDMA channel                                                */
  __IM  uint32_t  RESERVED20[424];
  __IOM uint32_t  POWER;                        /*!< Peripheral power control                                                  */
} NRF_RADIO_Type;                               /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                           UART0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal Asynchronous Receiver/Transmitter (UART0)
  */

typedef struct {                                /*!< UART0 Structure                                                           */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start UART receiver                                                       */
  __OM  uint32_t  TASKS_STOPRX;                 /*!< Stop UART receiver                                                        */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start UART transmitter                                                    */
  __OM  uint32_t  TASKS_STOPTX;                 /*!< Stop UART transmitter                                                     */
  __IM  uint32_t  RESERVED[3];
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend UART                                                              */
  __IM  uint32_t  RESERVED1[56];
  __IOM uint32_t  EVENTS_CTS;                   /*!< CTS is activated (set low). Clear To Send.                                */
  __IOM uint32_t  EVENTS_NCTS;                  /*!< CTS is deactivated (set high). Not Clear To Send.                         */
  __IOM uint32_t  EVENTS_RXDRDY;                /*!< Data received in RXD                                                      */
  __IM  uint32_t  RESERVED2[4];
  __IOM uint32_t  EVENTS_TXDRDY;                /*!< Data sent from TXD                                                        */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Error detected                                                            */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  EVENTS_RXTO;                  /*!< Receiver timeout                                                          */
  __IM  uint32_t  RESERVED5[46];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED6[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[93];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED8[31];
  __IOM uint32_t  ENABLE;                       /*!< Enable UART                                                               */
  __IM  uint32_t  RESERVED9;
  __IOM UART_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RXD;                          /*!< RXD register                                                              */
  __OM  uint32_t  TXD;                          /*!< TXD register                                                              */
  __IM  uint32_t  RESERVED10;
  __IOM uint32_t  BAUDRATE;                     /*!< Baud rate. Accuracy depends on the HFCLK source selected.                 */
  __IM  uint32_t  RESERVED11[17];
  __IOM uint32_t  CONFIG;                       /*!< Configuration of parity and hardware flow control                         */
} NRF_UART_Type;                                /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                          UARTE0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief UART with EasyDMA 0 (UARTE0)
  */

typedef struct {                                /*!< UARTE0 Structure                                                          */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start UART receiver                                                       */
  __OM  uint32_t  TASKS_STOPRX;                 /*!< Stop UART receiver                                                        */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start UART transmitter                                                    */
  __OM  uint32_t  TASKS_STOPTX;                 /*!< Stop UART transmitter                                                     */
  __IM  uint32_t  RESERVED[7];
  __OM  uint32_t  TASKS_FLUSHRX;                /*!< Flush RX FIFO into RX buffer                                              */
  __IM  uint32_t  RESERVED1[52];
  __IOM uint32_t  EVENTS_CTS;                   /*!< CTS is activated (set low). Clear To Send.                                */
  __IOM uint32_t  EVENTS_NCTS;                  /*!< CTS is deactivated (set high). Not Clear To Send.                         */
  __IOM uint32_t  EVENTS_RXDRDY;                /*!< Data received in RXD (but potentially not yet transferred to
                                                     Data RAM)                                                                 */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< Receive buffer is filled up                                               */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_TXDRDY;                /*!< Data sent from TXD                                                        */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Last TX byte transmitted                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Error detected                                                            */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  EVENTS_RXTO;                  /*!< Receiver timeout                                                          */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< UART receiver has started                                                 */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< UART transmitter has started                                              */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  EVENTS_TXSTOPPED;             /*!< Transmitter stopped                                                       */
  __IM  uint32_t  RESERVED7[41];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[93];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source This register is read/write one to clear.                    */
  __IM  uint32_t  RESERVED10[31];
  __IOM uint32_t  ENABLE;                       /*!< Enable UART                                                               */
  __IM  uint32_t  RESERVED11;
  __IOM UARTE_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED12[3];
  __IOM uint32_t  BAUDRATE;                     /*!< Baud rate. Accuracy depends on the HFCLK source selected.                 */
  __IM  uint32_t  RESERVED13[3];
  __IOM UARTE_RXD_Type RXD;                     /*!< RXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED14;
  __IOM UARTE_TXD_Type TXD;                     /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED15[7];
  __IOM uint32_t  CONFIG;                       /*!< Configuration of parity and hardware flow control                         */
} NRF_UARTE_Type;                               /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                           SPI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Peripheral Interface 0 (SPI0)
  */

typedef struct {                                /*!< SPI0 Structure                                                            */
  __IM  uint32_t  RESERVED[66];
  __IOM uint32_t  EVENTS_READY;                 /*!< TXD byte sent and RXD byte received                                       */
  __IM  uint32_t  RESERVED1[126];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPI                                                                */
  __IM  uint32_t  RESERVED3;
  __IOM SPI_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED4;
  __IM  uint32_t  RXD;                          /*!< RXD register                                                              */
  __IOM uint32_t  TXD;                          /*!< TXD register                                                              */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  FREQUENCY;                    /*!< SPI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED6[11];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
} NRF_SPI_Type;                                 /*!< Size = 1368 (0x558)                                                       */



/* =========================================================================================================================== */
/* ================                                           SPIM0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Peripheral Interface Master with EasyDMA 0 (SPIM0)
  */

typedef struct {                                /*!< SPIM0 Structure                                                           */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_START;                  /*!< Start SPI transaction                                                     */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop SPI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend SPI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume SPI transaction                                                    */
  __IM  uint32_t  RESERVED2[56];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< SPI transaction has stopped                                               */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  EVENTS_END;                   /*!< End of RXD buffer and TXD buffer reached                                  */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< End of TXD buffer reached                                                 */
  __IM  uint32_t  RESERVED6[10];
  __IOM uint32_t  EVENTS_STARTED;               /*!< Transaction started                                                       */
  __IM  uint32_t  RESERVED7[44];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[61];
  __IOM uint32_t  STALLSTAT;                    /*!< Stall status for EasyDMA RAM accesses. The fields in this register
                                                     are set to STALL by hardware whenever a stall occurs and
                                                     can be cleared (set to NOSTALL) by the CPU.                               */
  __IM  uint32_t  RESERVED10[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPIM                                                               */
  __IM  uint32_t  RESERVED11;
  __IOM SPIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED12[3];
  __IOM uint32_t  FREQUENCY;                    /*!< SPI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED13[3];
  __IOM SPIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM SPIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED14[2];
  __IOM SPIM_IFTIMING_Type IFTIMING;            /*!< Unspecified                                                               */
  __IOM uint32_t  CSNPOL;                       /*!< Polarity of CSN output                                                    */
  __IOM uint32_t  PSELDCX;                      /*!< Pin select for DCX signal                                                 */
  __IOM uint32_t  DCXCNT;                       /*!< DCX configuration                                                         */
  __IM  uint32_t  RESERVED15[19];
  __IOM uint32_t  ORC;                          /*!< Byte transmitted after TXD.MAXCNT bytes have been transmitted
                                                     in the case when RXD.MAXCNT is greater than TXD.MAXCNT                    */
} NRF_SPIM_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                           SPIS0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief SPI Slave 0 (SPIS0)
  */

typedef struct {                                /*!< SPIS0 Structure                                                           */
  __IM  uint32_t  RESERVED[9];
  __OM  uint32_t  TASKS_ACQUIRE;                /*!< Acquire SPI semaphore                                                     */
  __OM  uint32_t  TASKS_RELEASE;                /*!< Release SPI semaphore, enabling the SPI slave to acquire it               */
  __IM  uint32_t  RESERVED1[54];
  __IOM uint32_t  EVENTS_END;                   /*!< Granted transaction completed                                             */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED3[5];
  __IOM uint32_t  EVENTS_ACQUIRED;              /*!< Semaphore acquired                                                        */
  __IM  uint32_t  RESERVED4[53];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED5[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[61];
  __IM  uint32_t  SEMSTAT;                      /*!< Semaphore status register                                                 */
  __IM  uint32_t  RESERVED7[15];
  __IOM uint32_t  STATUS;                       /*!< Status from last transaction                                              */
  __IM  uint32_t  RESERVED8[47];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPI slave                                                          */
  __IM  uint32_t  RESERVED9;
  __IOM SPIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED10[7];
  __IOM SPIS_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IOM SPIS_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  DEF;                          /*!< Default character. Character clocked out in case of an ignored
                                                     transaction.                                                              */
  __IM  uint32_t  RESERVED12[24];
  __IOM uint32_t  ORC;                          /*!< Over-read character                                                       */
} NRF_SPIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                           TWI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Interface 0 (TWI0)
  */

typedef struct {                                /*!< TWI0 Structure                                                            */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start TWI receive sequence                                                */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start TWI transmit sequence                                               */
  __IM  uint32_t  RESERVED1[2];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction                                                      */
  __IM  uint32_t  RESERVED2;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED3[56];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IOM uint32_t  EVENTS_RXDREADY;              /*!< TWI RXD byte received                                                     */
  __IM  uint32_t  RESERVED4[4];
  __IOM uint32_t  EVENTS_TXDSENT;               /*!< TWI TXD byte sent                                                         */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED6[4];
  __IOM uint32_t  EVENTS_BB;                    /*!< TWI byte boundary, generated before each byte that is sent or
                                                     received                                                                  */
  __IM  uint32_t  RESERVED7[3];
  __IOM uint32_t  EVENTS_SUSPENDED;             /*!< TWI entered the suspended state                                           */
  __IM  uint32_t  RESERVED8[45];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED9[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED10[110];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED11[14];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWI                                                                */
  __IM  uint32_t  RESERVED12;
  __IOM TWI_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED13[2];
  __IM  uint32_t  RXD;                          /*!< RXD register                                                              */
  __IOM uint32_t  TXD;                          /*!< TXD register                                                              */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  FREQUENCY;                    /*!< TWI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED15[24];
  __IOM uint32_t  ADDRESS;                      /*!< Address used in the TWI transfer                                          */
} NRF_TWI_Type;                                 /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                           TWIM0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Master Interface with EasyDMA 0 (TWIM0)
  */

typedef struct {                                /*!< TWIM0 Structure                                                           */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start TWI receive sequence                                                */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start TWI transmit sequence                                               */
  __IM  uint32_t  RESERVED1[2];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction. Must be issued while the TWI master is
                                                     not suspended.                                                            */
  __IM  uint32_t  RESERVED2;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED3[56];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED5[8];
  __IOM uint32_t  EVENTS_SUSPENDED;             /*!< SUSPEND task has been issued, TWI traffic is now suspended.               */
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  EVENTS_LASTRX;                /*!< Byte boundary, starting to receive the last byte                          */
  __IOM uint32_t  EVENTS_LASTTX;                /*!< Byte boundary, starting to transmit the last byte                         */
  __IM  uint32_t  RESERVED7[39];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[110];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED10[14];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIM                                                               */
  __IM  uint32_t  RESERVED11;
  __IOM TWIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED12[5];
  __IOM uint32_t  FREQUENCY;                    /*!< TWI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED13[3];
  __IOM TWIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED14[13];
  __IOM uint32_t  ADDRESS;                      /*!< Address used in the TWI transfer                                          */
} NRF_TWIM_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                           TWIS0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Slave Interface with EasyDMA 0 (TWIS0)
  */

typedef struct {                                /*!< TWIS0 Structure                                                           */
  __IM  uint32_t  RESERVED[5];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED2[3];
  __OM  uint32_t  TASKS_PREPARERX;              /*!< Prepare the TWI slave to respond to a write command                       */
  __OM  uint32_t  TASKS_PREPARETX;              /*!< Prepare the TWI slave to respond to a read command                        */
  __IM  uint32_t  RESERVED3[51];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED5[9];
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED6[4];
  __IOM uint32_t  EVENTS_WRITE;                 /*!< Write command received                                                    */
  __IOM uint32_t  EVENTS_READ;                  /*!< Read command received                                                     */
  __IM  uint32_t  RESERVED7[37];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[113];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  MATCH;                        /*!< Status register indicating which address had a match                      */
  __IM  uint32_t  RESERVED10[10];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIS                                                               */
  __IM  uint32_t  RESERVED11;
  __IOM TWIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED12[9];
  __IOM TWIS_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIS_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED13[13];
  __IOM uint32_t  ADDRESS[2];                   /*!< Description collection: TWI slave address n                               */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  CONFIG;                       /*!< Configuration register for the address match mechanism                    */
  __IM  uint32_t  RESERVED15[10];
  __IOM uint32_t  ORC;                          /*!< Over-read character. Character sent out in case of an over-read
                                                     of the transmit buffer.                                                   */
} NRF_TWIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                           NFCT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief NFC-A compatible radio (NFCT)
  */

typedef struct {                                /*!< NFCT Structure                                                            */
  __OM  uint32_t  TASKS_ACTIVATE;               /*!< Activate NFCT peripheral for incoming and outgoing frames, change
                                                     state to activated                                                        */
  __OM  uint32_t  TASKS_DISABLE;                /*!< Disable NFCT peripheral                                                   */
  __OM  uint32_t  TASKS_SENSE;                  /*!< Enable NFC sense field mode, change state to sense mode                   */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start transmission of an outgoing frame, change state to transmit         */
  __IM  uint32_t  RESERVED[3];
  __OM  uint32_t  TASKS_ENABLERXDATA;           /*!< Initializes the EasyDMA for receive.                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_GOIDLE;                 /*!< Force state machine to IDLE state                                         */
  __OM  uint32_t  TASKS_GOSLEEP;                /*!< Force state machine to SLEEP_A state                                      */
  __IM  uint32_t  RESERVED2[53];
  __IOM uint32_t  EVENTS_READY;                 /*!< The NFCT peripheral is ready to receive and send frames                   */
  __IOM uint32_t  EVENTS_FIELDDETECTED;         /*!< Remote NFC field detected                                                 */
  __IOM uint32_t  EVENTS_FIELDLOST;             /*!< Remote NFC field lost                                                     */
  __IOM uint32_t  EVENTS_TXFRAMESTART;          /*!< Marks the start of the first symbol of a transmitted frame                */
  __IOM uint32_t  EVENTS_TXFRAMEEND;            /*!< Marks the end of the last transmitted on-air symbol of a frame            */
  __IOM uint32_t  EVENTS_RXFRAMESTART;          /*!< Marks the end of the first symbol of a received frame                     */
  __IOM uint32_t  EVENTS_RXFRAMEEND;            /*!< Received data has been checked (CRC, parity) and transferred
                                                     to RAM, and EasyDMA has ended accessing the RX buffer                     */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< NFC error reported. The ERRORSTATUS register contains details
                                                     on the source of the error.                                               */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_RXERROR;               /*!< NFC RX frame error reported. The FRAMESTATUS.RX register contains
                                                     details on the source of the error.                                       */
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< RX buffer (as defined by PACKETPTR and MAXLEN) in Data RAM full.          */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Transmission of data in RAM has ended, and EasyDMA has ended
                                                     accessing the TX buffer                                                   */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  EVENTS_AUTOCOLRESSTARTED;     /*!< Auto collision resolution process has started                             */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  EVENTS_COLLISION;             /*!< NFC auto collision resolution error reported.                             */
  __IOM uint32_t  EVENTS_SELECTED;              /*!< NFC auto collision resolution successfully completed                      */
  __IOM uint32_t  EVENTS_STARTED;               /*!< EasyDMA is ready to receive or send frames.                               */
  __IM  uint32_t  RESERVED6[43];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED7[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED8[62];
  __IOM uint32_t  ERRORSTATUS;                  /*!< NFC Error Status register                                                 */
  __IM  uint32_t  RESERVED9;
  __IOM NFCT_FRAMESTATUS_Type FRAMESTATUS;      /*!< Unspecified                                                               */
  __IM  uint32_t  NFCTAGSTATE;                  /*!< NfcTag state register                                                     */
  __IM  uint32_t  RESERVED10[3];
  __IM  uint32_t  SLEEPSTATE;                   /*!< Sleep state during automatic collision resolution                         */
  __IM  uint32_t  RESERVED11[6];
  __IM  uint32_t  FIELDPRESENT;                 /*!< Indicates the presence or not of a valid field                            */
  __IM  uint32_t  RESERVED12[49];
  __IOM uint32_t  FRAMEDELAYMIN;                /*!< Minimum frame delay                                                       */
  __IOM uint32_t  FRAMEDELAYMAX;                /*!< Maximum frame delay                                                       */
  __IOM uint32_t  FRAMEDELAYMODE;               /*!< Configuration register for the Frame Delay Timer                          */
  __IOM uint32_t  PACKETPTR;                    /*!< Packet pointer for TXD and RXD data storage in Data RAM                   */
  __IOM uint32_t  MAXLEN;                       /*!< Size of the RAM buffer allocated to TXD and RXD data storage
                                                     each                                                                      */
  __IOM NFCT_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM NFCT_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED13;
  __IOM uint32_t  MODULATIONCTRL;               /*!< Enables the modulation output to a GPIO pin which can be connected
                                                     to a second external antenna.                                             */
  __IM  uint32_t  RESERVED14[2];
  __IOM uint32_t  MODULATIONPSEL;               /*!< Pin select for Modulation control.                                        */
  __IM  uint32_t  RESERVED15[21];
  __IOM uint32_t  NFCID1_LAST;                  /*!< Last NFCID1 part (4, 7 or 10 bytes ID)                                    */
  __IOM uint32_t  NFCID1_2ND_LAST;              /*!< Second last NFCID1 part (7 or 10 bytes ID)                                */
  __IOM uint32_t  NFCID1_3RD_LAST;              /*!< Third last NFCID1 part (10 bytes ID)                                      */
  __IOM uint32_t  AUTOCOLRESCONFIG;             /*!< Controls the auto collision resolution function. This setting
                                                     must be done before the NFCT peripheral is activated.                     */
  __IOM uint32_t  SENSRES;                      /*!< NFC-A SENS_RES auto-response settings                                     */
  __IOM uint32_t  SELRES;                       /*!< NFC-A SEL_RES auto-response settings                                      */
} NRF_NFCT_Type;                                /*!< Size = 1448 (0x5a8)                                                       */



/* =========================================================================================================================== */
/* ================                                          GPIOTE                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Tasks and Events (GPIOTE)
  */

typedef struct {                                /*!< GPIOTE Structure                                                          */
  __OM  uint32_t  TASKS_OUT[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is configured in CONFIG[n].POLARITY.        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_SET[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it high.                          */
  __IM  uint32_t  RESERVED1[4];
  __OM  uint32_t  TASKS_CLR[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it low.                           */
  __IM  uint32_t  RESERVED2[32];
  __IOM uint32_t  EVENTS_IN[8];                 /*!< Description collection: Event generated from pin specified in
                                                     CONFIG[n].PSEL                                                            */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  EVENTS_PORT;                  /*!< Event generated from multiple input GPIO pins with SENSE mechanism
                                                     enabled                                                                   */
  __IM  uint32_t  RESERVED4[97];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[129];
  __IOM uint32_t  CONFIG[8];                    /*!< Description collection: Configuration for OUT[n], SET[n], and
                                                     CLR[n] tasks and IN[n] event                                              */
} NRF_GPIOTE_Type;                              /*!< Size = 1328 (0x530)                                                       */



/* =========================================================================================================================== */
/* ================                                           SAADC                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Successive approximation register (SAR) analog-to-digital converter (SAADC)
  */

typedef struct {                                /*!< SAADC Structure                                                           */
  __OM  uint32_t  TASKS_START;                  /*!< Starts the SAADC and prepares the result buffer in RAM                    */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Takes one SAADC sample                                                    */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops the SAADC and terminates all on-going conversions                   */
  __OM  uint32_t  TASKS_CALIBRATEOFFSET;        /*!< Starts offset auto-calibration                                            */
  __IM  uint32_t  RESERVED[60];
  __IOM uint32_t  EVENTS_STARTED;               /*!< The SAADC has started                                                     */
  __IOM uint32_t  EVENTS_END;                   /*!< The SAADC has filled up the result buffer                                 */
  __IOM uint32_t  EVENTS_DONE;                  /*!< A conversion task has been completed. Depending on the configuration,
                                                     multiple conversions might be needed for a result to be
                                                     transferred to RAM.                                                       */
  __IOM uint32_t  EVENTS_RESULTDONE;            /*!< Result ready for transfer to RAM                                          */
  __IOM uint32_t  EVENTS_CALIBRATEDONE;         /*!< Calibration is complete                                                   */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< The SAADC has stopped                                                     */
  __IOM SAADC_EVENTS_CH_Type EVENTS_CH[8];      /*!< Peripheral events.                                                        */
  __IM  uint32_t  RESERVED1[106];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[61];
  __IM  uint32_t  STATUS;                       /*!< Status                                                                    */
  __IM  uint32_t  RESERVED3[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable or disable SAADC                                                   */
  __IM  uint32_t  RESERVED4[3];
  __IOM SAADC_CH_Type CH[8];                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[24];
  __IOM uint32_t  RESOLUTION;                   /*!< Resolution configuration                                                  */
  __IOM uint32_t  OVERSAMPLE;                   /*!< Oversampling configuration. The RESOLUTION is applied before
                                                     averaging, thus for high OVERSAMPLE a higher RESOLUTION
                                                     should be used.                                                           */
  __IOM uint32_t  SAMPLERATE;                   /*!< Controls normal or continuous sample rate                                 */
  __IM  uint32_t  RESERVED6[12];
  __IOM SAADC_RESULT_Type RESULT;               /*!< RESULT EasyDMA channel                                                    */
} NRF_SAADC_Type;                               /*!< Size = 1592 (0x638)                                                       */



/* =========================================================================================================================== */
/* ================                                          TIMER0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Timer/Counter 0 (TIMER0)
  */

typedef struct {                                /*!< TIMER0 Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Start Timer                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop Timer                                                                */
  __OM  uint32_t  TASKS_COUNT;                  /*!< Increment Timer (Counter mode only)                                       */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear time                                                                */
  __OM  uint32_t  TASKS_SHUTDOWN;               /*!< Deprecated register - Shut down timer                                     */
  __IM  uint32_t  RESERVED[11];
  __OM  uint32_t  TASKS_CAPTURE[6];             /*!< Description collection: Capture Timer value to CC[n] register             */
  __IM  uint32_t  RESERVED1[58];
  __IOM uint32_t  EVENTS_COMPARE[6];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED2[42];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED3[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[126];
  __IOM uint32_t  MODE;                         /*!< Timer mode selection                                                      */
  __IOM uint32_t  BITMODE;                      /*!< Configure the number of bits used by the TIMER                            */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  PRESCALER;                    /*!< Timer prescaler register                                                  */
  __IM  uint32_t  RESERVED6[11];
  __IOM uint32_t  CC[6];                        /*!< Description collection: Capture/Compare register n                        */
} NRF_TIMER_Type;                               /*!< Size = 1368 (0x558)                                                       */



/* =========================================================================================================================== */
/* ================                                           RTC0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Real time counter 0 (RTC0)
  */

typedef struct {                                /*!< RTC0 Structure                                                            */
  __OM  uint32_t  TASKS_START;                  /*!< Start RTC COUNTER                                                         */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RTC COUNTER                                                          */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear RTC COUNTER                                                         */
  __OM  uint32_t  TASKS_TRIGOVRFLW;             /*!< Set COUNTER to 0xFFFFF0                                                   */
  __IM  uint32_t  RESERVED[60];
  __IOM uint32_t  EVENTS_TICK;                  /*!< Event on COUNTER increment                                                */
  __IOM uint32_t  EVENTS_OVRFLW;                /*!< Event on COUNTER overflow                                                 */
  __IM  uint32_t  RESERVED1[14];
  __IOM uint32_t  EVENTS_COMPARE[4];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED2[109];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[13];
  __IOM uint32_t  EVTEN;                        /*!< Enable or disable event routing                                           */
  __IOM uint32_t  EVTENSET;                     /*!< Enable event routing                                                      */
  __IOM uint32_t  EVTENCLR;                     /*!< Disable event routing                                                     */
  __IM  uint32_t  RESERVED4[110];
  __IM  uint32_t  COUNTER;                      /*!< Current COUNTER value                                                     */
  __IOM uint32_t  PRESCALER;                    /*!< 12 bit prescaler for COUNTER frequency (32768/(PRESCALER+1)).
                                                     Must be written when RTC is stopped.                                      */
  __IM  uint32_t  RESERVED5[13];
  __IOM uint32_t  CC[4];                        /*!< Description collection: Compare register n                                */
} NRF_RTC_Type;                                 /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                           TEMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor (TEMP)
  */

typedef struct {                                /*!< TEMP Structure                                                            */
  __OM  uint32_t  TASKS_START;                  /*!< Start temperature measurement                                             */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop temperature measurement                                              */
  __IM  uint32_t  RESERVED[62];
  __IOM uint32_t  EVENTS_DATARDY;               /*!< Temperature measurement complete, data ready                              */
  __IM  uint32_t  RESERVED1[128];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[127];
  __IM  int32_t   TEMP;                         /*!< Temperature in degC (0.25deg steps)                                       */
  __IM  uint32_t  RESERVED3[5];
  __IOM uint32_t  A0;                           /*!< Slope of first piecewise linear function                                  */
  __IOM uint32_t  A1;                           /*!< Slope of second piecewise linear function                                 */
  __IOM uint32_t  A2;                           /*!< Slope of third piecewise linear function                                  */
  __IOM uint32_t  A3;                           /*!< Slope of fourth piecewise linear function                                 */
  __IOM uint32_t  A4;                           /*!< Slope of fifth piecewise linear function                                  */
  __IOM uint32_t  A5;                           /*!< Slope of sixth piecewise linear function                                  */
  __IM  uint32_t  RESERVED4[2];
  __IOM uint32_t  B0;                           /*!< y-intercept of first piecewise linear function                            */
  __IOM uint32_t  B1;                           /*!< y-intercept of second piecewise linear function                           */
  __IOM uint32_t  B2;                           /*!< y-intercept of third piecewise linear function                            */
  __IOM uint32_t  B3;                           /*!< y-intercept of fourth piecewise linear function                           */
  __IOM uint32_t  B4;                           /*!< y-intercept of fifth piecewise linear function                            */
  __IOM uint32_t  B5;                           /*!< y-intercept of sixth piecewise linear function                            */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  T0;                           /*!< End point of first piecewise linear function                              */
  __IOM uint32_t  T1;                           /*!< End point of second piecewise linear function                             */
  __IOM uint32_t  T2;                           /*!< End point of third piecewise linear function                              */
  __IOM uint32_t  T3;                           /*!< End point of fourth piecewise linear function                             */
  __IOM uint32_t  T4;                           /*!< End point of fifth piecewise linear function                              */
} NRF_TEMP_Type;                                /*!< Size = 1396 (0x574)                                                       */



/* =========================================================================================================================== */
/* ================                                            RNG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Random Number Generator (RNG)
  */

typedef struct {                                /*!< RNG Structure                                                             */
  __OM  uint32_t  TASKS_START;                  /*!< Task starting the random number generator                                 */
  __OM  uint32_t  TASKS_STOP;                   /*!< Task stopping the random number generator                                 */
  __IM  uint32_t  RESERVED[62];
  __IOM uint32_t  EVENTS_VALRDY;                /*!< Event being generated for every new random number written to
                                                     the VALUE register                                                        */
  __IM  uint32_t  RESERVED1[63];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED2[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[126];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  VALUE;                        /*!< Output random number                                                      */
} NRF_RNG_Type;                                 /*!< Size = 1292 (0x50c)                                                       */



/* =========================================================================================================================== */
/* ================                                            ECB                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief AES ECB Mode Encryption (ECB)
  */

typedef struct {                                /*!< ECB Structure                                                             */
  __OM  uint32_t  TASKS_STARTECB;               /*!< Start ECB block encrypt                                                   */
  __OM  uint32_t  TASKS_STOPECB;                /*!< Abort a possible executing ECB operation                                  */
  __IM  uint32_t  RESERVED[62];
  __IOM uint32_t  EVENTS_ENDECB;                /*!< ECB block encrypt complete                                                */
  __IOM uint32_t  EVENTS_ERRORECB;              /*!< ECB block encrypt aborted because of a STOPECB task or due to
                                                     an error                                                                  */
  __IM  uint32_t  RESERVED1[127];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[126];
  __IOM uint32_t  ECBDATAPTR;                   /*!< ECB block encrypt memory pointers                                         */
} NRF_ECB_Type;                                 /*!< Size = 1288 (0x508)                                                       */



/* =========================================================================================================================== */
/* ================                                            AAR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Accelerated Address Resolver (AAR)
  */

typedef struct {                                /*!< AAR Structure                                                             */
  __OM  uint32_t  TASKS_START;                  /*!< Start resolving addresses based on IRKs specified in the IRK
                                                     data structure                                                            */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop resolving addresses                                                  */
  __IM  uint32_t  RESERVED1[61];
  __IOM uint32_t  EVENTS_END;                   /*!< Address resolution procedure complete                                     */
  __IOM uint32_t  EVENTS_RESOLVED;              /*!< Address resolved                                                          */
  __IOM uint32_t  EVENTS_NOTRESOLVED;           /*!< Address not resolved                                                      */
  __IM  uint32_t  RESERVED2[126];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  STATUS;                       /*!< Resolution status                                                         */
  __IM  uint32_t  RESERVED4[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable AAR                                                                */
  __IOM uint32_t  NIRK;                         /*!< Number of IRKs                                                            */
  __IOM uint32_t  IRKPTR;                       /*!< Pointer to IRK data structure                                             */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  ADDRPTR;                      /*!< Pointer to the resolvable address                                         */
  __IOM uint32_t  SCRATCHPTR;                   /*!< Pointer to data area used for temporary storage                           */
} NRF_AAR_Type;                                 /*!< Size = 1304 (0x518)                                                       */



/* =========================================================================================================================== */
/* ================                                            CCM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief AES CCM mode encryption (CCM)
  */

typedef struct {                                /*!< CCM Structure                                                             */
  __OM  uint32_t  TASKS_KSGEN;                  /*!< Start generation of keystream. This operation will stop by itself
                                                     when completed.                                                           */
  __OM  uint32_t  TASKS_CRYPT;                  /*!< Start encryption/decryption. This operation will stop by itself
                                                     when completed.                                                           */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop encryption/decryption                                                */
  __OM  uint32_t  TASKS_RATEOVERRIDE;           /*!< Override DATARATE setting in MODE register with the contents
                                                     of the RATEOVERRIDE register for any ongoing encryption/decryption        */
  __IM  uint32_t  RESERVED[60];
  __IOM uint32_t  EVENTS_ENDKSGEN;              /*!< Keystream generation complete                                             */
  __IOM uint32_t  EVENTS_ENDCRYPT;              /*!< Encrypt/decrypt complete                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Deprecated register - CCM error event                                     */
  __IM  uint32_t  RESERVED1[61];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED2[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  MICSTATUS;                    /*!< MIC check result                                                          */
  __IM  uint32_t  RESERVED4[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable                                                                    */
  __IOM uint32_t  MODE;                         /*!< Operation mode                                                            */
  __IOM uint32_t  CNFPTR;                       /*!< Pointer to data structure holding the AES key and the NONCE
                                                     vector                                                                    */
  __IOM uint32_t  INPTR;                        /*!< Input pointer                                                             */
  __IOM uint32_t  OUTPTR;                       /*!< Output pointer                                                            */
  __IOM uint32_t  SCRATCHPTR;                   /*!< Pointer to data area used for temporary storage                           */
  __IOM uint32_t  MAXPACKETSIZE;                /*!< Length of keystream generated when MODE.LENGTH = Extended                 */
  __IOM uint32_t  RATEOVERRIDE;                 /*!< Data rate override setting.                                               */
  __IOM uint32_t  HEADERMASK;                   /*!< Header (S0) mask.                                                         */
} NRF_CCM_Type;                                 /*!< Size = 1316 (0x524)                                                       */



/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer (WDT)
  */

typedef struct {                                /*!< WDT Structure                                                             */
  __OM  uint32_t  TASKS_START;                  /*!< Start the watchdog                                                        */
  __IM  uint32_t  RESERVED[63];
  __IOM uint32_t  EVENTS_TIMEOUT;               /*!< Watchdog timeout                                                          */
  __IM  uint32_t  RESERVED1[128];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[61];
  __IM  uint32_t  RUNSTATUS;                    /*!< Run status                                                                */
  __IM  uint32_t  REQSTATUS;                    /*!< Request status                                                            */
  __IM  uint32_t  RESERVED3[63];
  __IOM uint32_t  CRV;                          /*!< Counter reload value                                                      */
  __IOM uint32_t  RREN;                         /*!< Enable register for reload request registers                              */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED4[60];
  __OM  uint32_t  RR[8];                        /*!< Description collection: Reload request n                                  */
} NRF_WDT_Type;                                 /*!< Size = 1568 (0x620)                                                       */



/* =========================================================================================================================== */
/* ================                                           QDEC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Quadrature Decoder (QDEC)
  */

typedef struct {                                /*!< QDEC Structure                                                            */
  __OM  uint32_t  TASKS_START;                  /*!< Task starting the quadrature decoder                                      */
  __OM  uint32_t  TASKS_STOP;                   /*!< Task stopping the quadrature decoder                                      */
  __OM  uint32_t  TASKS_READCLRACC;             /*!< Read and clear ACC and ACCDBL                                             */
  __OM  uint32_t  TASKS_RDCLRACC;               /*!< Read and clear ACC                                                        */
  __OM  uint32_t  TASKS_RDCLRDBL;               /*!< Read and clear ACCDBL                                                     */
  __IM  uint32_t  RESERVED[59];
  __IOM uint32_t  EVENTS_SAMPLERDY;             /*!< Event being generated for every new sample value written to
                                                     the SAMPLE register                                                       */
  __IOM uint32_t  EVENTS_REPORTRDY;             /*!< Non-null report ready                                                     */
  __IOM uint32_t  EVENTS_ACCOF;                 /*!< ACC or ACCDBL register overflow                                           */
  __IOM uint32_t  EVENTS_DBLRDY;                /*!< Double displacement(s) detected                                           */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< QDEC has been stopped                                                     */
  __IM  uint32_t  RESERVED1[59];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED2[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable the quadrature decoder                                             */
  __IOM uint32_t  LEDPOL;                       /*!< LED output pin polarity                                                   */
  __IOM uint32_t  SAMPLEPER;                    /*!< Sample period                                                             */
  __IM  int32_t   SAMPLE;                       /*!< Motion sample value                                                       */
  __IOM uint32_t  REPORTPER;                    /*!< Number of samples to be taken before REPORTRDY and DBLRDY events
                                                     can be generated                                                          */
  __IM  int32_t   ACC;                          /*!< Register accumulating the valid transitions                               */
  __IM  int32_t   ACCREAD;                      /*!< Snapshot of the ACC register, updated by the READCLRACC or RDCLRACC
                                                     task                                                                      */
  __IOM QDEC_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IOM uint32_t  DBFEN;                        /*!< Enable input debounce filters                                             */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  LEDPRE;                       /*!< Time period the LED is switched ON prior to sampling                      */
  __IM  uint32_t  ACCDBL;                       /*!< Register accumulating the number of detected double transitions           */
  __IM  uint32_t  ACCDBLREAD;                   /*!< Snapshot of the ACCDBL, updated by the READCLRACC or RDCLRDBL
                                                     task                                                                      */
} NRF_QDEC_Type;                                /*!< Size = 1356 (0x54c)                                                       */



/* =========================================================================================================================== */
/* ================                                           COMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (COMP)
  */

typedef struct {                                /*!< COMP Structure                                                            */
  __OM  uint32_t  TASKS_START;                  /*!< Start comparator                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop comparator                                                           */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Sample comparator value                                                   */
  __IM  uint32_t  RESERVED[61];
  __IOM uint32_t  EVENTS_READY;                 /*!< COMP is ready and output is valid                                         */
  __IOM uint32_t  EVENTS_DOWN;                  /*!< Downward crossing                                                         */
  __IOM uint32_t  EVENTS_UP;                    /*!< Upward crossing                                                           */
  __IOM uint32_t  EVENTS_CROSS;                 /*!< Downward or upward crossing                                               */
  __IM  uint32_t  RESERVED1[60];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED2[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  RESULT;                       /*!< Compare result                                                            */
  __IM  uint32_t  RESERVED4[63];
  __IOM uint32_t  ENABLE;                       /*!< COMP enable                                                               */
  __IOM uint32_t  PSEL;                         /*!< Pin select                                                                */
  __IOM uint32_t  REFSEL;                       /*!< Reference source select for single-ended mode                             */
  __IOM uint32_t  EXTREFSEL;                    /*!< External reference select                                                 */
  __IM  uint32_t  RESERVED5[8];
  __IOM uint32_t  TH;                           /*!< Threshold configuration for hysteresis unit                               */
  __IOM uint32_t  MODE;                         /*!< Mode configuration                                                        */
  __IOM uint32_t  HYST;                         /*!< Comparator hysteresis enable                                              */
} NRF_COMP_Type;                                /*!< Size = 1340 (0x53c)                                                       */



/* =========================================================================================================================== */
/* ================                                          LPCOMP                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Low-power comparator (LPCOMP)
  */

typedef struct {                                /*!< LPCOMP Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Start comparator                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop comparator                                                           */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Sample comparator value                                                   */
  __IM  uint32_t  RESERVED[61];
  __IOM uint32_t  EVENTS_READY;                 /*!< LPCOMP is ready and output is valid                                       */
  __IOM uint32_t  EVENTS_DOWN;                  /*!< Downward crossing                                                         */
  __IOM uint32_t  EVENTS_UP;                    /*!< Upward crossing                                                           */
  __IOM uint32_t  EVENTS_CROSS;                 /*!< Downward or upward crossing                                               */
  __IM  uint32_t  RESERVED1[60];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED2[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  RESULT;                       /*!< Compare result                                                            */
  __IM  uint32_t  RESERVED4[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable LPCOMP                                                             */
  __IOM uint32_t  PSEL;                         /*!< Input pin select                                                          */
  __IOM uint32_t  REFSEL;                       /*!< Reference select                                                          */
  __IOM uint32_t  EXTREFSEL;                    /*!< External reference select                                                 */
  __IM  uint32_t  RESERVED5[4];
  __IOM uint32_t  ANADETECT;                    /*!< Analog detect configuration                                               */
  __IM  uint32_t  RESERVED6[5];
  __IOM uint32_t  HYST;                         /*!< Comparator hysteresis enable                                              */
} NRF_LPCOMP_Type;                              /*!< Size = 1340 (0x53c)                                                       */



/* =========================================================================================================================== */
/* ================                                           EGU0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Event generator unit 0 (EGU0)
  */

typedef struct {                                /*!< EGU0 Structure                                                            */
  __OM  uint32_t  TASKS_TRIGGER[16];            /*!< Description collection: Trigger n for triggering the corresponding
                                                     TRIGGERED[n] event                                                        */
  __IM  uint32_t  RESERVED[48];
  __IOM uint32_t  EVENTS_TRIGGERED[16];         /*!< Description collection: Event number n generated by triggering
                                                     the corresponding TRIGGER[n] task                                         */
  __IM  uint32_t  RESERVED1[112];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
} NRF_EGU_Type;                                 /*!< Size = 780 (0x30c)                                                        */



/* =========================================================================================================================== */
/* ================                                           SWI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Software interrupt 0 (SWI0)
  */

typedef struct {                                /*!< SWI0 Structure                                                            */
  __IM  uint32_t  UNUSED;                       /*!< Unused.                                                                   */
} NRF_SWI_Type;                                 /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                           PWM0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse width modulation unit 0 (PWM0)
  */

typedef struct {                                /*!< PWM0 Structure                                                            */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PWM pulse generation on all channels at the end of current
                                                     PWM period, and stops sequence playback                                   */
  __OM  uint32_t  TASKS_SEQSTART[2];            /*!< Description collection: Loads the first PWM value on all enabled
                                                     channels from sequence n, and starts playing that sequence
                                                     at the rate defined in SEQ[n]REFRESH and/or DECODER.MODE.
                                                     Causes PWM generation to start if not running.                            */
  __OM  uint32_t  TASKS_NEXTSTEP;               /*!< Steps by one value in the current sequence on all enabled channels
                                                     if DECODER.MODE=NextStep. Does not cause PWM generation
                                                     to start if not running.                                                  */
  __IM  uint32_t  RESERVED1[60];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< Response to STOP task, emitted when PWM pulses are no longer
                                                     generated                                                                 */
  __IOM uint32_t  EVENTS_SEQSTARTED[2];         /*!< Description collection: First PWM period started on sequence
                                                     n                                                                         */
  __IOM uint32_t  EVENTS_SEQEND[2];             /*!< Description collection: Emitted at end of every sequence n,
                                                     when last value from RAM has been applied to wave counter                 */
  __IOM uint32_t  EVENTS_PWMPERIODEND;          /*!< Emitted at the end of each PWM period                                     */
  __IOM uint32_t  EVENTS_LOOPSDONE;             /*!< Concatenated sequences have been played the amount of times
                                                     defined in LOOP.CNT                                                       */
  __IM  uint32_t  RESERVED2[56];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED3[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[125];
  __IOM uint32_t  ENABLE;                       /*!< PWM module enable register                                                */
  __IOM uint32_t  MODE;                         /*!< Selects operating mode of the wave counter                                */
  __IOM uint32_t  COUNTERTOP;                   /*!< Value up to which the pulse generator counter counts                      */
  __IOM uint32_t  PRESCALER;                    /*!< Configuration for PWM_CLK                                                 */
  __IOM uint32_t  DECODER;                      /*!< Configuration of the decoder                                              */
  __IOM uint32_t  LOOP;                         /*!< Number of playbacks of a loop                                             */
  __IM  uint32_t  RESERVED5[2];
  __IOM PWM_SEQ_Type SEQ[2];                    /*!< Unspecified                                                               */
  __IOM PWM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_PWM_Type;                                 /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                            PDM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse Density Modulation (Digital Microphone) Interface (PDM)
  */

typedef struct {                                /*!< PDM Structure                                                             */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous PDM transfer                                            */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PDM transfer                                                        */
  __IM  uint32_t  RESERVED[62];
  __IOM uint32_t  EVENTS_STARTED;               /*!< PDM transfer has started                                                  */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< PDM transfer has finished                                                 */
  __IOM uint32_t  EVENTS_END;                   /*!< The PDM has written the last sample specified by SAMPLE.MAXCNT
                                                     (or the last sample after a STOP task has been received)
                                                     to Data RAM                                                               */
  __IM  uint32_t  RESERVED1[125];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED2[125];
  __IOM uint32_t  ENABLE;                       /*!< PDM module enable register                                                */
  __IOM uint32_t  PDMCLKCTRL;                   /*!< PDM clock generator control                                               */
  __IOM uint32_t  MODE;                         /*!< Defines the routing of the connected PDM microphones' signals             */
  __IM  uint32_t  RESERVED3[3];
  __IOM uint32_t  GAINL;                        /*!< Left output gain adjustment                                               */
  __IOM uint32_t  GAINR;                        /*!< Right output gain adjustment                                              */
  __IOM uint32_t  RATIO;                        /*!< Selects the ratio between PDM_CLK and output sample rate. Change
                                                     PDMCLKCTRL accordingly.                                                   */
  __IM  uint32_t  RESERVED4[7];
  __IOM PDM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[6];
  __IOM PDM_SAMPLE_Type SAMPLE;                 /*!< Unspecified                                                               */
} NRF_PDM_Type;                                 /*!< Size = 1384 (0x568)                                                       */



/* =========================================================================================================================== */
/* ================                                            ACL                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Access control lists (ACL)
  */

typedef struct {                                /*!< ACL Structure                                                             */
  __IM  uint32_t  RESERVED[512];
  __IOM ACL_ACL_Type ACL[8];                    /*!< Unspecified                                                               */
} NRF_ACL_Type;                                 /*!< Size = 2176 (0x880)                                                       */



/* =========================================================================================================================== */
/* ================                                           NVMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Non Volatile Memory Controller (NVMC)
  */

typedef struct {                                /*!< NVMC Structure                                                            */
  __IM  uint32_t  RESERVED[256];
  __IM  uint32_t  READY;                        /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED1;
  __IM  uint32_t  READYNEXT;                    /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED2[62];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  
  union {
    __OM  uint32_t ERASEPAGE;                   /*!< Register for erasing a page in code area                                  */
    __OM  uint32_t ERASEPCR1;                   /*!< Deprecated register - Register for erasing a page in code area,
                                                     equivalent to ERASEPAGE                                                   */
  };
  __OM  uint32_t  ERASEALL;                     /*!< Register for erasing all non-volatile user memory                         */
  __OM  uint32_t  ERASEPCR0;                    /*!< Deprecated register - Register for erasing a page in code area,
                                                     equivalent to ERASEPAGE                                                   */
  __OM  uint32_t  ERASEUICR;                    /*!< Register for erasing user information configuration registers             */
  __OM  uint32_t  ERASEPAGEPARTIAL;             /*!< Register for partial erase of a page in code area                         */
  __IOM uint32_t  ERASEPAGEPARTIALCFG;          /*!< Register for partial erase configuration                                  */
  __IM  uint32_t  RESERVED3[8];
  __IOM uint32_t  ICACHECNF;                    /*!< I-code cache configuration register                                       */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  IHIT;                         /*!< I-code cache hit counter                                                  */
  __IOM uint32_t  IMISS;                        /*!< I-code cache miss counter                                                 */
} NRF_NVMC_Type;                                /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                            PPI                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Programmable Peripheral Interconnect (PPI)
  */

typedef struct {                                /*!< PPI Structure                                                             */
  __OM  PPI_TASKS_CHG_Type TASKS_CHG[6];        /*!< Channel group tasks                                                       */
  __IM  uint32_t  RESERVED[308];
  __IOM uint32_t  CHEN;                         /*!< Channel enable register                                                   */
  __IOM uint32_t  CHENSET;                      /*!< Channel enable set register                                               */
  __IOM uint32_t  CHENCLR;                      /*!< Channel enable clear register                                             */
  __IM  uint32_t  RESERVED1;
  __IOM PPI_CH_Type CH[20];                     /*!< PPI Channel                                                               */
  __IM  uint32_t  RESERVED2[148];
  __IOM uint32_t  CHG[6];                       /*!< Description collection: Channel group n                                   */
  __IM  uint32_t  RESERVED3[62];
  __IOM PPI_FORK_Type FORK[32];                 /*!< Fork                                                                      */
} NRF_PPI_Type;                                 /*!< Size = 2448 (0x990)                                                       */



/* =========================================================================================================================== */
/* ================                                            MWU                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Memory Watch Unit (MWU)
  */

typedef struct {                                /*!< MWU Structure                                                             */
  __IM  uint32_t  RESERVED[64];
  __IOM MWU_EVENTS_REGION_Type EVENTS_REGION[4];/*!< Peripheral events.                                                        */
  __IM  uint32_t  RESERVED1[16];
  __IOM MWU_EVENTS_PREGION_Type EVENTS_PREGION[2];/*!< Peripheral events.                                                      */
  __IM  uint32_t  RESERVED2[100];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[5];
  __IOM uint32_t  NMIEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  NMIENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  NMIENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[53];
  __IOM MWU_PERREGION_Type PERREGION[2];        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[64];
  __IOM uint32_t  REGIONEN;                     /*!< Enable/disable regions watch                                              */
  __IOM uint32_t  REGIONENSET;                  /*!< Enable regions watch                                                      */
  __IOM uint32_t  REGIONENCLR;                  /*!< Disable regions watch                                                     */
  __IM  uint32_t  RESERVED6[57];
  __IOM MWU_REGION_Type REGION[4];              /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[32];
  __IOM MWU_PREGION_Type PREGION[2];            /*!< Unspecified                                                               */
} NRF_MWU_Type;                                 /*!< Size = 1760 (0x6e0)                                                       */



/* =========================================================================================================================== */
/* ================                                            I2S                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Inter-IC Sound (I2S)
  */

typedef struct {                                /*!< I2S Structure                                                             */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous I2S transfer. Also starts MCK generator when
                                                     this is enabled.                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops I2S transfer. Also stops MCK generator. Triggering this
                                                     task will cause the STOPPED event to be generated.                        */
  __IM  uint32_t  RESERVED[63];
  __IOM uint32_t  EVENTS_RXPTRUPD;              /*!< The RXD.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and RX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words that
                                                     are received on the SDIN pin.                                             */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< I2S transfer stopped.                                                     */
  __IM  uint32_t  RESERVED1[2];
  __IOM uint32_t  EVENTS_TXPTRUPD;              /*!< The TDX.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and TX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words that
                                                     are sent on the SDOUT pin.                                                */
  __IM  uint32_t  RESERVED2[122];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable I2S module.                                                        */
  __IOM I2S_CONFIG_Type CONFIG;                 /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED4[3];
  __IOM I2S_RXD_Type RXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5;
  __IOM I2S_TXD_Type TXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED6[3];
  __IOM I2S_RXTXD_Type RXTXD;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[3];
  __IOM I2S_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_I2S_Type;                                 /*!< Size = 1396 (0x574)                                                       */



/* =========================================================================================================================== */
/* ================                                            FPU                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief FPU (FPU)
  */

typedef struct {                                /*!< FPU Structure                                                             */
  __IM  uint32_t  UNUSED;                       /*!< Unused.                                                                   */
} NRF_FPU_Type;                                 /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                           USBD                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal serial bus device (USBD)
  */

typedef struct {                                /*!< USBD Structure                                                            */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTEPIN[8];           /*!< Description collection: Captures the EPIN[n].PTR and EPIN[n].MAXCNT
                                                     registers values, and enables endpoint IN n to respond
                                                     to traffic from host                                                      */
  __OM  uint32_t  TASKS_STARTISOIN;             /*!< Captures the ISOIN.PTR and ISOIN.MAXCNT registers values, and
                                                     enables sending data on ISO endpoint                                      */
  __OM  uint32_t  TASKS_STARTEPOUT[8];          /*!< Description collection: Captures the EPOUT[n].PTR and EPOUT[n].MAXCNT
                                                     registers values, and enables endpoint n to respond to
                                                     traffic from host                                                         */
  __OM  uint32_t  TASKS_STARTISOOUT;            /*!< Captures the ISOOUT.PTR and ISOOUT.MAXCNT registers values,
                                                     and enables receiving of data on ISO endpoint                             */
  __OM  uint32_t  TASKS_EP0RCVOUT;              /*!< Allows OUT data stage on control endpoint 0                               */
  __OM  uint32_t  TASKS_EP0STATUS;              /*!< Allows status stage on control endpoint 0                                 */
  __OM  uint32_t  TASKS_EP0STALL;               /*!< Stalls data and status stage on control endpoint 0                        */
  __OM  uint32_t  TASKS_DPDMDRIVE;              /*!< Forces D+ and D- lines into the state defined in the DPDMVALUE
                                                     register                                                                  */
  __OM  uint32_t  TASKS_DPDMNODRIVE;            /*!< Stops forcing D+ and D- lines into any state (USB engine takes
                                                     control)                                                                  */
  __IM  uint32_t  RESERVED1[40];
  __IOM uint32_t  EVENTS_USBRESET;              /*!< Signals that a USB reset condition has been detected on USB
                                                     lines                                                                     */
  __IOM uint32_t  EVENTS_STARTED;               /*!< Confirms that the EPIN[n].PTR and EPIN[n].MAXCNT, or EPOUT[n].PTR
                                                     and EPOUT[n].MAXCNT registers have been captured on all
                                                     endpoints reported in the EPSTATUS register                               */
  __IOM uint32_t  EVENTS_ENDEPIN[8];            /*!< Description collection: The whole EPIN[n] buffer has been consumed.
                                                     The buffer can be accessed safely by software.                            */
  __IOM uint32_t  EVENTS_EP0DATADONE;           /*!< An acknowledged data transfer has taken place on the control
                                                     endpoint                                                                  */
  __IOM uint32_t  EVENTS_ENDISOIN;              /*!< The whole ISOIN buffer has been consumed. The buffer can be
                                                     accessed safely by software.                                              */
  __IOM uint32_t  EVENTS_ENDEPOUT[8];           /*!< Description collection: The whole EPOUT[n] buffer has been consumed.
                                                     The buffer can be accessed safely by software.                            */
  __IOM uint32_t  EVENTS_ENDISOOUT;             /*!< The whole ISOOUT buffer has been consumed. The buffer can be
                                                     accessed safely by software.                                              */
  __IOM uint32_t  EVENTS_SOF;                   /*!< Signals that a SOF (start of frame) condition has been detected
                                                     on USB lines                                                              */
  __IOM uint32_t  EVENTS_USBEVENT;              /*!< An event or an error not covered by specific events has occurred.
                                                     Check EVENTCAUSE register to find the cause.                              */
  __IOM uint32_t  EVENTS_EP0SETUP;              /*!< A valid SETUP token has been received (and acknowledged) on
                                                     the control endpoint                                                      */
  __IOM uint32_t  EVENTS_EPDATA;                /*!< A data transfer has occurred on a data endpoint, indicated by
                                                     the EPDATASTATUS register                                                 */
  __IM  uint32_t  RESERVED2[39];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED3[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[61];
  __IOM uint32_t  EVENTCAUSE;                   /*!< Details on what caused the USBEVENT event                                 */
  __IM  uint32_t  RESERVED5[7];
  __IOM USBD_HALTED_Type HALTED;                /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  EPSTATUS;                     /*!< Provides information on which endpoint's EasyDMA registers have
                                                     been captured                                                             */
  __IOM uint32_t  EPDATASTATUS;                 /*!< Provides information on which endpoint(s) an acknowledged data
                                                     transfer has occurred (EPDATA event)                                      */
  __IM  uint32_t  USBADDR;                      /*!< Device USB address                                                        */
  __IM  uint32_t  RESERVED7[3];
  __IM  uint32_t  BMREQUESTTYPE;                /*!< SETUP data, byte 0, bmRequestType                                         */
  __IM  uint32_t  BREQUEST;                     /*!< SETUP data, byte 1, bRequest                                              */
  __IM  uint32_t  WVALUEL;                      /*!< SETUP data, byte 2, LSB of wValue                                         */
  __IM  uint32_t  WVALUEH;                      /*!< SETUP data, byte 3, MSB of wValue                                         */
  __IM  uint32_t  WINDEXL;                      /*!< SETUP data, byte 4, LSB of wIndex                                         */
  __IM  uint32_t  WINDEXH;                      /*!< SETUP data, byte 5, MSB of wIndex                                         */
  __IM  uint32_t  WLENGTHL;                     /*!< SETUP data, byte 6, LSB of wLength                                        */
  __IM  uint32_t  WLENGTHH;                     /*!< SETUP data, byte 7, MSB of wLength                                        */
  __IOM USBD_SIZE_Type SIZE;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED8[15];
  __IOM uint32_t  ENABLE;                       /*!< Enable USB                                                                */
  __IOM uint32_t  USBPULLUP;                    /*!< Control of the USB pull-up                                                */
  __IOM uint32_t  DPDMVALUE;                    /*!< State D+ and D- lines will be forced into by the DPDMDRIVE task.
                                                     The DPDMNODRIVE task reverts the control of the lines to
                                                     MAC IP (no forcing).                                                      */
  __IOM uint32_t  DTOGGLE;                      /*!< Data toggle control and status                                            */
  __IOM uint32_t  EPINEN;                       /*!< Endpoint IN enable                                                        */
  __IOM uint32_t  EPOUTEN;                      /*!< Endpoint OUT enable                                                       */
  __OM  uint32_t  EPSTALL;                      /*!< STALL endpoints                                                           */
  __IOM uint32_t  ISOSPLIT;                     /*!< Controls the split of ISO buffers                                         */
  __IM  uint32_t  FRAMECNTR;                    /*!< Returns the current value of the start of frame counter                   */
  __IM  uint32_t  RESERVED9[2];
  __IOM uint32_t  LOWPOWER;                     /*!< Controls USBD peripheral low power mode during USB suspend                */
  __IOM uint32_t  ISOINCONFIG;                  /*!< Controls the response of the ISO IN endpoint to an IN token
                                                     when no data is ready to be sent                                          */
  __IM  uint32_t  RESERVED10[51];
  __IOM USBD_EPIN_Type EPIN[8];                 /*!< Unspecified                                                               */
  __IOM USBD_ISOIN_Type ISOIN;                  /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED11[21];
  __IOM USBD_EPOUT_Type EPOUT[8];               /*!< Unspecified                                                               */
  __IOM USBD_ISOOUT_Type ISOOUT;                /*!< Unspecified                                                               */
} NRF_USBD_Type;                                /*!< Size = 1964 (0x7ac)                                                       */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define NRF_FICR_BASE               0x10000000UL
#define NRF_UICR_BASE               0x10001000UL
#define NRF_APPROTECT_BASE          0x40000000UL
#define NRF_CLOCK_BASE              0x40000000UL
#define NRF_POWER_BASE              0x40000000UL
#define NRF_P0_BASE                 0x50000000UL
#define NRF_P1_BASE                 0x50000300UL
#define NRF_RADIO_BASE              0x40001000UL
#define NRF_UART0_BASE              0x40002000UL
#define NRF_UARTE0_BASE             0x40002000UL
#define NRF_SPI0_BASE               0x40003000UL
#define NRF_SPIM0_BASE              0x40003000UL
#define NRF_SPIS0_BASE              0x40003000UL
#define NRF_TWI0_BASE               0x40003000UL
#define NRF_TWIM0_BASE              0x40003000UL
#define NRF_TWIS0_BASE              0x40003000UL
#define NRF_SPI1_BASE               0x40004000UL
#define NRF_SPIM1_BASE              0x40004000UL
#define NRF_SPIS1_BASE              0x40004000UL
#define NRF_TWI1_BASE               0x40004000UL
#define NRF_TWIM1_BASE              0x40004000UL
#define NRF_TWIS1_BASE              0x40004000UL
#define NRF_NFCT_BASE               0x40005000UL
#define NRF_GPIOTE_BASE             0x40006000UL
#define NRF_SAADC_BASE              0x40007000UL
#define NRF_TIMER0_BASE             0x40008000UL
#define NRF_TIMER1_BASE             0x40009000UL
#define NRF_TIMER2_BASE             0x4000A000UL
#define NRF_RTC0_BASE               0x4000B000UL
#define NRF_TEMP_BASE               0x4000C000UL
#define NRF_RNG_BASE                0x4000D000UL
#define NRF_ECB_BASE                0x4000E000UL
#define NRF_AAR_BASE                0x4000F000UL
#define NRF_CCM_BASE                0x4000F000UL
#define NRF_WDT_BASE                0x40010000UL
#define NRF_RTC1_BASE               0x40011000UL
#define NRF_QDEC_BASE               0x40012000UL
#define NRF_COMP_BASE               0x40013000UL
#define NRF_LPCOMP_BASE             0x40013000UL
#define NRF_EGU0_BASE               0x40014000UL
#define NRF_SWI0_BASE               0x40014000UL
#define NRF_EGU1_BASE               0x40015000UL
#define NRF_SWI1_BASE               0x40015000UL
#define NRF_EGU2_BASE               0x40016000UL
#define NRF_SWI2_BASE               0x40016000UL
#define NRF_EGU3_BASE               0x40017000UL
#define NRF_SWI3_BASE               0x40017000UL
#define NRF_EGU4_BASE               0x40018000UL
#define NRF_SWI4_BASE               0x40018000UL
#define NRF_EGU5_BASE               0x40019000UL
#define NRF_SWI5_BASE               0x40019000UL
#define NRF_TIMER3_BASE             0x4001A000UL
#define NRF_TIMER4_BASE             0x4001B000UL
#define NRF_PWM0_BASE               0x4001C000UL
#define NRF_PDM_BASE                0x4001D000UL
#define NRF_ACL_BASE                0x4001E000UL
#define NRF_NVMC_BASE               0x4001E000UL
#define NRF_PPI_BASE                0x4001F000UL
#define NRF_MWU_BASE                0x40020000UL
#define NRF_PWM1_BASE               0x40021000UL
#define NRF_PWM2_BASE               0x40022000UL
#define NRF_SPI2_BASE               0x40023000UL
#define NRF_SPIM2_BASE              0x40023000UL
#define NRF_SPIS2_BASE              0x40023000UL
#define NRF_RTC2_BASE               0x40024000UL
#define NRF_I2S_BASE                0x40025000UL
#define NRF_FPU_BASE                0x40026000UL
#define NRF_USBD_BASE               0x40027000UL
#define NRF_UARTE1_BASE             0x40028000UL
#define NRF_PWM3_BASE               0x4002D000UL
#define NRF_SPIM3_BASE              0x4002F000UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define NRF_FICR                    ((NRF_FICR_Type*)          NRF_FICR_BASE)
#define NRF_UICR                    ((NRF_UICR_Type*)          NRF_UICR_BASE)
#define NRF_APPROTECT               ((NRF_APPROTECT_Type*)     NRF_APPROTECT_BASE)
#define NRF_CLOCK                   ((NRF_CLOCK_Type*)         NRF_CLOCK_BASE)
#define NRF_POWER                   ((NRF_POWER_Type*)         NRF_POWER_BASE)
#define NRF_P0                      ((NRF_GPIO_Type*)          NRF_P0_BASE)
#define NRF_P1                      ((NRF_GPIO_Type*)          NRF_P1_BASE)
#define NRF_RADIO                   ((NRF_RADIO_Type*)         NRF_RADIO_BASE)
#define NRF_UART0                   ((NRF_UART_Type*)          NRF_UART0_BASE)
#define NRF_UARTE0                  ((NRF_UARTE_Type*)         NRF_UARTE0_BASE)
#define NRF_SPI0                    ((NRF_SPI_Type*)           NRF_SPI0_BASE)
#define NRF_SPIM0                   ((NRF_SPIM_Type*)          NRF_SPIM0_BASE)
#define NRF_SPIS0                   ((NRF_SPIS_Type*)          NRF_SPIS0_BASE)
#define NRF_TWI0                    ((NRF_TWI_Type*)           NRF_TWI0_BASE)
#define NRF_TWIM0                   ((NRF_TWIM_Type*)          NRF_TWIM0_BASE)
#define NRF_TWIS0                   ((NRF_TWIS_Type*)          NRF_TWIS0_BASE)
#define NRF_SPI1                    ((NRF_SPI_Type*)           NRF_SPI1_BASE)
#define NRF_SPIM1                   ((NRF_SPIM_Type*)          NRF_SPIM1_BASE)
#define NRF_SPIS1                   ((NRF_SPIS_Type*)          NRF_SPIS1_BASE)
#define NRF_TWI1                    ((NRF_TWI_Type*)           NRF_TWI1_BASE)
#define NRF_TWIM1                   ((NRF_TWIM_Type*)          NRF_TWIM1_BASE)
#define NRF_TWIS1                   ((NRF_TWIS_Type*)          NRF_TWIS1_BASE)
#define NRF_NFCT                    ((NRF_NFCT_Type*)          NRF_NFCT_BASE)
#define NRF_GPIOTE                  ((NRF_GPIOTE_Type*)        NRF_GPIOTE_BASE)
#define NRF_SAADC                   ((NRF_SAADC_Type*)         NRF_SAADC_BASE)
#define NRF_TIMER0                  ((NRF_TIMER_Type*)         NRF_TIMER0_BASE)
#define NRF_TIMER1                  ((NRF_TIMER_Type*)         NRF_TIMER1_BASE)
#define NRF_TIMER2                  ((NRF_TIMER_Type*)         NRF_TIMER2_BASE)
#define NRF_RTC0                    ((NRF_RTC_Type*)           NRF_RTC0_BASE)
#define NRF_TEMP                    ((NRF_TEMP_Type*)          NRF_TEMP_BASE)
#define NRF_RNG                     ((NRF_RNG_Type*)           NRF_RNG_BASE)
#define NRF_ECB                     ((NRF_ECB_Type*)           NRF_ECB_BASE)
#define NRF_AAR                     ((NRF_AAR_Type*)           NRF_AAR_BASE)
#define NRF_CCM                     ((NRF_CCM_Type*)           NRF_CCM_BASE)
#define NRF_WDT                     ((NRF_WDT_Type*)           NRF_WDT_BASE)
#define NRF_RTC1                    ((NRF_RTC_Type*)           NRF_RTC1_BASE)
#define NRF_QDEC                    ((NRF_QDEC_Type*)          NRF_QDEC_BASE)
#define NRF_COMP                    ((NRF_COMP_Type*)          NRF_COMP_BASE)
#define NRF_LPCOMP                  ((NRF_LPCOMP_Type*)        NRF_LPCOMP_BASE)
#define NRF_EGU0                    ((NRF_EGU_Type*)           NRF_EGU0_BASE)
#define NRF_SWI0                    ((NRF_SWI_Type*)           NRF_SWI0_BASE)
#define NRF_EGU1                    ((NRF_EGU_Type*)           NRF_EGU1_BASE)
#define NRF_SWI1                    ((NRF_SWI_Type*)           NRF_SWI1_BASE)
#define NRF_EGU2                    ((NRF_EGU_Type*)           NRF_EGU2_BASE)
#define NRF_SWI2                    ((NRF_SWI_Type*)           NRF_SWI2_BASE)
#define NRF_EGU3                    ((NRF_EGU_Type*)           NRF_EGU3_BASE)
#define NRF_SWI3                    ((NRF_SWI_Type*)           NRF_SWI3_BASE)
#define NRF_EGU4                    ((NRF_EGU_Type*)           NRF_EGU4_BASE)
#define NRF_SWI4                    ((NRF_SWI_Type*)           NRF_SWI4_BASE)
#define NRF_EGU5                    ((NRF_EGU_Type*)           NRF_EGU5_BASE)
#define NRF_SWI5                    ((NRF_SWI_Type*)           NRF_SWI5_BASE)
#define NRF_TIMER3                  ((NRF_TIMER_Type*)         NRF_TIMER3_BASE)
#define NRF_TIMER4                  ((NRF_TIMER_Type*)         NRF_TIMER4_BASE)
#define NRF_PWM0                    ((NRF_PWM_Type*)           NRF_PWM0_BASE)
#define NRF_PDM                     ((NRF_PDM_Type*)           NRF_PDM_BASE)
#define NRF_ACL                     ((NRF_ACL_Type*)           NRF_ACL_BASE)
#define NRF_NVMC                    ((NRF_NVMC_Type*)          NRF_NVMC_BASE)
#define NRF_PPI                     ((NRF_PPI_Type*)           NRF_PPI_BASE)
#define NRF_MWU                     ((NRF_MWU_Type*)           NRF_MWU_BASE)
#define NRF_PWM1                    ((NRF_PWM_Type*)           NRF_PWM1_BASE)
#define NRF_PWM2                    ((NRF_PWM_Type*)           NRF_PWM2_BASE)
#define NRF_SPI2                    ((NRF_SPI_Type*)           NRF_SPI2_BASE)
#define NRF_SPIM2                   ((NRF_SPIM_Type*)          NRF_SPIM2_BASE)
#define NRF_SPIS2                   ((NRF_SPIS_Type*)          NRF_SPIS2_BASE)
#define NRF_RTC2                    ((NRF_RTC_Type*)           NRF_RTC2_BASE)
#define NRF_I2S                     ((NRF_I2S_Type*)           NRF_I2S_BASE)
#define NRF_FPU                     ((NRF_FPU_Type*)           NRF_FPU_BASE)
#define NRF_USBD                    ((NRF_USBD_Type*)          NRF_USBD_BASE)
#define NRF_UARTE1                  ((NRF_UARTE_Type*)         NRF_UARTE1_BASE)
#define NRF_PWM3                    ((NRF_PWM_Type*)           NRF_PWM3_BASE)
#define NRF_SPIM3                   ((NRF_SPIM_Type*)          NRF_SPIM3_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


/* =========================================  End of section using anonymous unions  ========================================= */
#if defined (__CC_ARM)
  #pragma pop
#elif defined (__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic pop
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning restore
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#endif


#ifdef __cplusplus
}
#endif

#endif /* NRF52833_H */


/** @} */ /* End of group nrf52833 */

/** @} */ /* End of group Nordic Semiconductor */
